#ifndef __JUCER_HEADER_MAINCOMPONENT_MAINCOMPONENT_1B7BCD76__
#define __JUCER_HEADER_MAINCOMPONENT_MAINCOMPONENT_1B7BCD76__

#include "includes_juce.h"
#include "ToolbarWorker.h"
#include "ThemeComponent.h"

class MainComponent  : public Component 
//class MainComponent  : public ThemeComponent 
{
public:
	MainComponent ();
	~MainComponent();

	TabbedComponent* tabbedComponent;

	void paint(Graphics& g);
	void resized();
	void currentTabChanged(const int newCurrentTabIndex, const String &newCurrentTabName);
	void popupMenuClickOnTab(const int newCurrentTabIndex, const String &newCurrentTabName);
   	//void themeChanged(); 

	juce_UseDebuggingNewOperator

private:
    
	MainComponent (const MainComponent&);
	const MainComponent& operator= (const MainComponent&);
};

/*class MainPage: public ButtonListener,
                public ComboBoxListener,
		public Component*/
class MainPage: public ThemeComponent,
		//public ButtonListener,
		public ComboBoxListener
{
private:
    Colour getRandomBrightColour(void);

public:

	MainPage(TabbedComponent *);
	~MainPage();

	void paint(Graphics& g);
	void resized();
	void buttonClicked (Button* buttonThatWasClicked);
	void comboBoxChanged (ComboBox* comboBoxThatHasChanged);
	void paintFont(String color);
	void printToOutputEditor(char *msg);
	void displayVlanHopOptions();
	void displayAceOptions();
	void displayAceAndVlan();
	void displayMitmMode();
	void removeMitmMode();
	void removeVlanOptionGroup();
	void removeAceOptionGroup();
	void removeVlan();
	void removeAce();
	void freeTargetsMemory();
	void themeChanged();

private:

	TabbedComponent* mainTabbedComponent;
	TextButton* quitButton;
	TextButton* startUCSniffButton;
	TextButton* stopUCSniffButton;
	TextButton* clearButton;
	ComboBox* comboBox;
	ComboBox* comboBoxInterface;
	TextEditor* outputEditor;
	GroupComponent* vlanHopGroupComponent;
	ToggleButton* yesVlanButton;
	ToggleButton* noVlanButton;
	GroupComponent* vlanOptionGroupComponent;
	ToggleButton* spoofCDPButton;
	ToggleButton* sniffCDPButton;
	ToggleButton* specifyVlanIDButton;
	TextEditor* vlanEditor;
	GroupComponent* aceGroupComponent;
	ToggleButton* yesAceButton;
	ToggleButton* noAceButton;
	GroupComponent* aceOptionsGroupComponent;
	TextEditor* macAceEditor;
	GroupComponent* modeGroupComponent;
	ToggleButton* mitmButton;
	ToggleButton* monitorButton;
	GroupComponent* mitmModeGroupComponent;
	ToggleButton* learningButton;
	ToggleButton* targetButton;
	GroupComponent* miscGroupComponent;
	ToggleButton* garpButton;
	ToggleButton* sipLogButton;
	ToggleButton* verboseButton;
	ToggleButton* garpdButton;
	ToggleButton* tftpmButton;
	ToggleButton* mixAvButton;
	Label* labelEnterMAC;	
	ToolbarWorker* tb;
	ThemeComponent* themes;
	Label* labelInterface;
	Label* labelMode;
	Label* labelOandStats;
	Label* labelStartUCS;
	Label* labelStopUCS;

	TooltipWindow tooltipWindow;

	static const char* viperlablogosm_gif;
	static const int viperlablogosm_gifSize;
	static const char* viperlablogomed_jpg;
	static const int viperlablogomed_jpgSize;
	static const char* ucSniffblueicon_png;
	static const int ucSniffblueicon_pngSize;
	static const char* ucsniffshield_png;
	static const int ucsniffshield_pngSize;
	static const char* ucSniffdarkgreyicon_png;
	static const int ucSniffdarkgreyicon_pngSize;
	static const char* ucsniffdarkblue_png;
	static const int ucsniffdarkblue_pngSize;
	static const char* ucsniffdarkgrey_png;
	static const int ucsniffdarkgrey_pngSize;
	static const char* ucsniffdarkred_png;
	static const int ucsniffdarkred_pngSize;
	Image* topLogoimageucsniffdarkblue;
	Image* topLogoimageucsniffdarkred;
	Image* topLogoimageucsniffdarkgrey;

	int userVlanID;
	int vlanOptionEnabled;
	int getVlanIDFromEditor;
	int mitmYes;
	Colour backgroundColour;

};


#endif   // __JUCER_HEADER_MAINCOMPONENT_MAINCOMPONENT_1B7BCD76__
