#ifndef THEMECOMPONENT_H
#define THEMECOMPONENT_H

#include "includes_juce.h"
#include "SkinWorker.h"

class ThemeComponent : public SkinWorker,		
			   public ButtonListener
{
public:
	ThemeComponent(void *ptr);
	~ThemeComponent();
	ThemeComponent() { compObjPtr = NULL; }

	void paint (Graphics& g);
	void resized();
	void buttonClicked (Button* buttonThatWasClicked);
	virtual void themeChanged();

	juce_UseDebuggingNewOperator

private:
	TextButton* textButtonApply;
	TextButton* textButtonClose;
	int color;
	ThemeComponent *compObjPtr;
	String newColor;
	Label* labelSipera;
	Label* labelVIPER;
	Label* labelLAVA;
	Label* labelClassic;
	ImageButton* imageButtonSipera1;
	ImageButton* imageButtonSipera2;
	ImageButton* imageButtonSipera3;
	ImageButton* imageButtonSipera4;
	ImageButton* imageButtonSipera5;
	ImageButton* imageButtonVIPER1;
	ImageButton* imageButtonVIPER2;
	ImageButton* imageButtonVIPER3;
	ImageButton* imageButtonVIPER4;
	ImageButton* imageButtonVIPER5;
	ImageButton* imageButtonLAVA1;
	ImageButton* imageButtonLAVA2;
	ImageButton* imageButtonLAVA3;
	ImageButton* imageButtonLAVA4;
	ImageButton* imageButtonLAVA5;
	ImageButton* imageButtonClassic1;
	ImageButton* imageButtonClassic2;
	ImageButton* imageButtonClassic3;
	ImageButton* imageButtonClassic4;
	ImageButton* imageButtonClassic5;
	
	ThemeComponent (const ThemeComponent&);
	const ThemeComponent& operator= (const ThemeComponent&);
};

#endif
