#include "ThemeComponent.h"
#include "ColorWindow.h"
#include "SkinWorker.h"
#include "ImageData.h"

extern ColorWindow* colorWindow;
extern int myColor;

ThemeComponent::ThemeComponent(void *ptr)
	: textButtonApply (0),
	  textButtonClose(0),
	  newColor(0),
	  color(0),
	  labelSipera(0),
	  labelVIPER(0),
          labelLAVA(0),
          labelClassic(0),
	  imageButtonSipera1 (0),
          imageButtonSipera2 (0),
          imageButtonSipera3 (0),
          imageButtonSipera4 (0),
          imageButtonSipera5 (0),
          imageButtonVIPER1 (0),
          imageButtonVIPER2 (0),
          imageButtonVIPER3 (0),
          imageButtonVIPER4 (0),
          imageButtonVIPER5 (0),
          imageButtonLAVA1 (0),
          imageButtonLAVA2 (0),
          imageButtonLAVA3 (0),
          imageButtonLAVA4 (0),
          imageButtonLAVA5 (0),
          imageButtonClassic1 (0),
          imageButtonClassic2 (0),
          imageButtonClassic3 (0),
          imageButtonClassic4 (0),
          imageButtonClassic5 (0)
{
	compObjPtr = (ThemeComponent *)ptr;

	// Add Sipera buttons
	addAndMakeVisible (imageButtonSipera1 = new ImageButton (T("new button")));
	imageButtonSipera1->setButtonText (T("Sipera 1"));
	imageButtonSipera1->addButtonListener (this);
	imageButtonSipera1->setImages (false, true, true,
                                   ImageCache::getFromMemory (ImageData::sipera1small_png, ImageData::sipera1small_pngSize), 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonSipera2 = new ImageButton (T("new button")));
	imageButtonSipera2->setButtonText (T("Sipera 2"));
	imageButtonSipera2->addButtonListener (this);
	imageButtonSipera2->setImages (false, true, true,
                                   ImageCache::getFromMemory (ImageData::sipera2small_png, ImageData::sipera2small_pngSize), 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonSipera3 = new ImageButton (T("new button")));
	imageButtonSipera3->setButtonText (T("Sipera 3"));
	imageButtonSipera3->addButtonListener (this);
	imageButtonSipera3->setImages (false, true, true,
                                   ImageCache::getFromMemory (ImageData::sipera3small_png, ImageData::sipera3small_pngSize), 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0));
	
	addAndMakeVisible (imageButtonSipera4 = new ImageButton (T("new button")));
	imageButtonSipera4->setButtonText (T("Sipera 4"));
	imageButtonSipera4->addButtonListener (this);
	imageButtonSipera4->setImages (false, true, true,
                                   ImageCache::getFromMemory (ImageData::sipera4small_png, ImageData::sipera4small_pngSize), 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0));
	
	addAndMakeVisible (imageButtonSipera5 = new ImageButton (T("new button")));
	imageButtonSipera5->setButtonText (T("Sipera 5"));
	imageButtonSipera5->addButtonListener (this);
	imageButtonSipera5->setImages (false, true, true,
                                   ImageCache::getFromMemory (ImageData::sipera5small_png, ImageData::sipera5small_pngSize), 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0),
                                   0, 1.0000f, Colour (0x0));

	// VIPER image buttons
	addAndMakeVisible (imageButtonVIPER1 = new ImageButton (T("new button")));
	imageButtonVIPER1->setButtonText (T("VIPER 1"));
	imageButtonVIPER1->addButtonListener (this);
	imageButtonVIPER1->setImages (false, true, true,
                                  ImageCache::getFromMemory (ImageData::viper1small_png, ImageData::viper1small_pngSize), 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonVIPER2 = new ImageButton (T("new button")));
	imageButtonVIPER2->setButtonText (T("VIPER 2"));
	imageButtonVIPER2->addButtonListener (this);
	imageButtonVIPER2->setImages (false, true, true,
                                  ImageCache::getFromMemory (ImageData::viper2small_png, ImageData::viper2small_pngSize), 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonVIPER3 = new ImageButton (T("new button")));
	imageButtonVIPER3->setButtonText (T("VIPER 3"));
	imageButtonVIPER3->addButtonListener (this);
	imageButtonVIPER3->setImages (false, true, true,
                                  ImageCache::getFromMemory (ImageData::viper3small_png, ImageData::viper3small_pngSize), 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonVIPER4 = new ImageButton (T("new button")));
	imageButtonVIPER4->setButtonText (T("VIPER 4"));
	imageButtonVIPER4->addButtonListener (this);
	imageButtonVIPER4->setImages (false, true, true,
                                  ImageCache::getFromMemory (ImageData::viper4small_png, ImageData::viper4small_pngSize), 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonVIPER5 = new ImageButton (T("new button")));
	imageButtonVIPER5->setButtonText (T("VIPER 5"));
	imageButtonVIPER5->addButtonListener (this);
	imageButtonVIPER5->setImages (false, true, true,
                                  ImageCache::getFromMemory (ImageData::viper5small_png, ImageData::viper5small_pngSize), 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0),
                                  0, 1.0000f, Colour (0x0));

	// Add LAVA image buttons
	addAndMakeVisible (imageButtonLAVA1 = new ImageButton (T("new button")));
	imageButtonLAVA1->setButtonText (T("LAVA 1"));
	imageButtonLAVA1->addButtonListener (this);
	imageButtonLAVA1->setImages (false, true, true,
                                 ImageCache::getFromMemory (ImageData::lava1small_png, ImageData::lava1small_pngSize), 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonLAVA2 = new ImageButton (T("new button")));
	imageButtonLAVA2->setButtonText (T("LAVA 2"));
	imageButtonLAVA2->addButtonListener (this);
	imageButtonLAVA2->setImages (false, true, true,
                                 ImageCache::getFromMemory (ImageData::lava2small_png, ImageData::lava2small_pngSize), 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonLAVA3 = new ImageButton (T("new button")));
	imageButtonLAVA3->setButtonText (T("LAVA 3"));
	imageButtonLAVA3->addButtonListener (this);
	imageButtonLAVA3->setImages (false, true, true,
                                 ImageCache::getFromMemory (ImageData::lava3small_png, ImageData::lava3small_pngSize), 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonLAVA4 = new ImageButton (T("new button")));
	imageButtonLAVA4->setButtonText (T("LAVA 4"));
	imageButtonLAVA4->addButtonListener (this);
	imageButtonLAVA4->setImages (false, true, true,
                                 ImageCache::getFromMemory (ImageData::lava4small_png, ImageData::lava4small_pngSize), 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonLAVA5 = new ImageButton (T("new button")));
	imageButtonLAVA5->setButtonText (T("LAVA 5"));
	imageButtonLAVA5->addButtonListener (this);
	imageButtonLAVA5->setImages (false, true, true,
                                 ImageCache::getFromMemory (ImageData::lava5small_png, ImageData::lava5small_pngSize), 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0),
                                 0, 1.0000f, Colour (0x0));

	// Add Classic image buttons
	addAndMakeVisible (imageButtonClassic1 = new ImageButton (T("new button")));
	imageButtonClassic1->setButtonText (T("Classic 1"));
	imageButtonClassic1->addButtonListener (this);
	imageButtonClassic1->setImages (false, true, true,
				ImageCache::getFromMemory (ImageData::classic1small_png, ImageData::classic1small_pngSize), 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonClassic2 = new ImageButton (T("new button")));
	imageButtonClassic2->setButtonText (T("Classic 2"));
	imageButtonClassic2->addButtonListener (this);
	imageButtonClassic2->setImages (false, true, true,
				ImageCache::getFromMemory (ImageData::classic2small_png, ImageData::classic2small_pngSize), 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonClassic3 = new ImageButton (T("new button")));
	imageButtonClassic3->setButtonText (T("Classic 3"));
	imageButtonClassic3->addButtonListener (this);
	imageButtonClassic3->setImages (false, true, true,
                                ImageCache::getFromMemory (ImageData::classic3small_png, ImageData::classic3small_pngSize), 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonClassic4 = new ImageButton (T("new button")));
	imageButtonClassic4->setButtonText (T("Classic 4"));
	imageButtonClassic4->addButtonListener (this);
	imageButtonClassic4->setImages (false, true, true,
                                ImageCache::getFromMemory (ImageData::classic4small_png, ImageData::classic4small_pngSize), 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0));

	addAndMakeVisible (imageButtonClassic5 = new ImageButton (T("new button")));
	imageButtonClassic5->setButtonText (T("Classic 5"));
	imageButtonClassic5->addButtonListener (this);
	imageButtonClassic5->setImages (false, true, true,
                                ImageCache::getFromMemory (ImageData::classic5small_png, ImageData::classic5small_pngSize), 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0),
                                    0, 1.0000f, Colour (0x0));

	// Apply, Close buttons
        addAndMakeVisible (textButtonApply = new TextButton (T("ApplyButton")));
	textButtonApply->setButtonText (T("Apply"));
	textButtonApply->addButtonListener (this);

	addAndMakeVisible (textButtonClose = new TextButton (T("BackButton")));
	textButtonClose->setButtonText (T("Close"));
	textButtonClose->addButtonListener (this);

	// Add the labels for different themes
	addAndMakeVisible (labelSipera = new Label (T("new label"),
                                          T("Sipera")));
	labelSipera->setTooltip (T("Sipera Systems "));
	labelSipera->setFont (Font (17.0000f, Font::bold));
	labelSipera->setJustificationType (Justification::centredLeft);
	labelSipera->setEditable (false, false, false);
	labelSipera->setColour (TextEditor::textColourId, Colours::black);
	labelSipera->setColour (TextEditor::backgroundColourId, Colour (0x0));

	addAndMakeVisible (labelVIPER = new Label (T("new label"),
                                           T("VIPER VAST")));
	labelVIPER->setTooltip (T("VIPER Lab VAST colours"));
	labelVIPER->setFont (Font (17.0000f, Font::bold));
	labelVIPER->setJustificationType (Justification::centredLeft);
	labelVIPER->setEditable (false, false, false);
	labelVIPER->setColour (TextEditor::textColourId, Colours::black);
	labelVIPER->setColour (TextEditor::backgroundColourId, Colour (0x0));

	addAndMakeVisible (labelLAVA = new Label (T("new label"),
                                           T("VIPER LAVA")));
	labelLAVA->setFont (Font (17.0000f, Font::bold));
	labelLAVA->setJustificationType (Justification::centredLeft);
	labelLAVA->setEditable (false, false, false);
	labelLAVA->setColour (TextEditor::textColourId, Colours::black);
	labelLAVA->setColour (TextEditor::backgroundColourId, Colour (0x0));

	addAndMakeVisible (labelClassic = new Label (T("new label"),
                                           T("Classic")));
	labelClassic->setFont (Font (17.0000f, Font::bold));
	labelClassic->setJustificationType (Justification::centredLeft);
	labelClassic->setEditable (false, false, false);
	labelClassic->setColour (TextEditor::textColourId, Colours::black);
	labelClassic->setColour (TextEditor::backgroundColourId, Colour (0x0));

	setBoundsRelative(0.0547f, 0.0931f, 0.8860f, 0.7022f);
}

ThemeComponent::~ThemeComponent()
{
	if(compObjPtr)
	{
		deleteAndZero(textButtonClose);
		deleteAndZero(textButtonApply);
		deleteAndZero (imageButtonSipera1);
		deleteAndZero (imageButtonSipera2);
		deleteAndZero (imageButtonSipera3);
		deleteAndZero (imageButtonSipera4);
		deleteAndZero (imageButtonSipera5);
		deleteAndZero (imageButtonVIPER1);
		deleteAndZero (imageButtonVIPER2);
		deleteAndZero (imageButtonVIPER3);
		deleteAndZero (imageButtonVIPER4);
		deleteAndZero (imageButtonVIPER5);
		deleteAndZero (imageButtonLAVA1);
		deleteAndZero (imageButtonLAVA2);
		deleteAndZero (imageButtonLAVA3);
		deleteAndZero (imageButtonLAVA4);
		deleteAndZero (imageButtonLAVA5);
		deleteAndZero (imageButtonClassic1);
		deleteAndZero (imageButtonClassic2);
		deleteAndZero (imageButtonClassic3);
		deleteAndZero (imageButtonClassic4);
		deleteAndZero (imageButtonClassic5);
		deleteAndZero(labelSipera);
		deleteAndZero(labelVIPER);
		deleteAndZero(labelLAVA);
		deleteAndZero(labelClassic);
	}
}

void ThemeComponent::paint (Graphics& g) {

	g.fillAll(Colours::white);

	if(color == 1) {
		// sipera1
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xffcde420),
                                       (float) (proportionOfWidth (0.2881f)), (float) (proportionOfHeight (0.3675f)),
                                       Colour (0xff131b2b),
                                       (float) (proportionOfWidth (0.6091f)), (float) (proportionOfHeight (0.7351f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));
	}

	if(color == 2) {
		// sipera2
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xff4b699d),
                                       (float) (proportionOfWidth (0.3210f)), (float) (proportionOfHeight (0.1225f)),
                                       Colour (0xff131b2b),
                                       (float) (proportionOfWidth (0.5432f)), (float) (proportionOfHeight (0.4900f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));
	}

	if (color == 3) {
		// sipera3
		g.setGradientFill (ColourGradient (Colour (0xfff6f6f6),
                                       (float) (proportionOfWidth (0.9300f)), (float) (proportionOfHeight (0.3430f)),
                                       Colour (0xff131b2b),
                                       (float) (proportionOfWidth (0.9794f)), (float) (proportionOfHeight (0.3430f)),
                                       false));
		g.fillRect (proportionOfWidth (0.1523f), proportionOfHeight (0.0000f), proportionOfWidth (0.8518f), proportionOfHeight (1.0000f));
		g.setGradientFill (ColourGradient (Colour (0xff131b2b),
                                       (float) (proportionOfWidth (0.0247f)), (float) (proportionOfHeight (0.4655f)),
                                       Colour (0xff4b699d),
                                       (float) (proportionOfWidth (0.0988f)), (float) (proportionOfHeight (0.4655f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.1317f), proportionOfHeight (1.0000f));
		g.setColour (Colour (0xfff6f6f6));
		g.fillRect (proportionOfWidth (0.0905f), proportionOfHeight (0.0000f), proportionOfWidth (0.0658f), proportionOfHeight (1.0000f));
		g.setColour (Colour (0xffcde420));
		g.fillRect (proportionOfWidth (0.1070f), proportionOfHeight (0.0000f), proportionOfWidth (0.0082f), proportionOfHeight (1.0000f)); 
	}
	if (color == 4) {
		// sipera4
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xffcde420),
                                       (float) (proportionOfWidth (0.1646f)), (float) (proportionOfHeight (0.1838f)),
                                       Colour (0xff4b699d),
                                       (float) (proportionOfWidth (0.4527f)), (float) (proportionOfHeight (0.3430f)),
                                       true));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));
	}

	if (color == 5) {
		// sipera5
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xff131b2b),
                                       (float) (proportionOfWidth (0.0823f)), (float) (proportionOfHeight (0.5145f)),
                                       Colour (0xff4b699d),
                                       (float) (proportionOfWidth (0.3045f)), (float) (proportionOfHeight (0.5145f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
		g.setGradientFill (ColourGradient (Colour (0xffcde420),
                                       (float) (proportionOfWidth (0.9136f)), (float) (proportionOfHeight (0.5268f)),
                                       Colour (0xff4b699d),
                                       (float) (proportionOfWidth (0.6996f)), (float) (proportionOfHeight (0.5391f)),
                                       false));
		g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
	}

	if(color == 6) {
		// viper1 
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xff003f5f),
                                       (float) (proportionOfWidth (0.3704f)), (float) (proportionOfHeight (0.4655f)),
                                       Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.6008f)), (float) (proportionOfHeight (0.4655f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));
	}
	if(color == 7) {
		// viper2
		/*g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xff003f5f),
                                       (float) (proportionOfWidth (0.0988f)), (float) (proportionOfHeight (0.7718f)),
                                       Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.3457f)), (float) (proportionOfHeight (0.8576f)),
                                       true));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
		g.setGradientFill (ColourGradient (Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.6091f)), (float) (proportionOfHeight (0.1225f)),
                                       Colour (0xff4e89a7),
                                       (float) (proportionOfWidth (0.6667f)), (float) (proportionOfHeight (0.2450f)),
                                       true));
		g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));*/

		g.setGradientFill (ColourGradient (Colour (0xffe4e8ee),
			432.0f, 448.0f,
			Colour (0xff131b2b),
			728.0f, 384.0f,
			false));
			g.fillRect (0, 0, proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));


	}
	if(color == 8) {
		// viper3
		g.fillAll (Colour (0xff003f5f));
		g.setGradientFill (ColourGradient (Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.1975f)), (float) (proportionOfHeight (0.5268f)),
                                       Colour (0xff4e89a7),
                                       (float) (proportionOfWidth (0.4198f)), (float) (proportionOfHeight (0.5268f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));
	}
	if(color == 9) {
		// viper4

	g.fillAll (Colours::white);
	g.setGradientFill (ColourGradient (Colours::aliceblue,
                                       (float) (proportionOfWidth (0.4280f)), (float) (proportionOfHeight (0.2687f)),
                                       //Colour (0xff183290),
                                       Colour (0xff131b2b),
                                       (float) (proportionOfWidth (0.3704f)), (float) (proportionOfHeight (0.4397f)),
                                       true));
	g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (0.5000f));
	g.setGradientFill (ColourGradient (Colours::aliceblue,
                                       (float) (proportionOfWidth (0.2222f)), (float) (proportionOfHeight (0.8672f)),
                                      Colour (0xff131b2b),
                                       (float) (proportionOfWidth (0.1646f)), (float) (proportionOfHeight (0.7328f)),
                                       true));
	g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.5000f), proportionOfWidth (0.5000f), proportionOfHeight (0.5000f));

	g.setGradientFill (ColourGradient (Colours::azure,
                                       (float) (proportionOfWidth (0.9053f)), (float) (proportionOfHeight (0.8916f)),
                                      Colour (0xff131b2b),
                                       (float) (proportionOfWidth (0.8395f)), (float) (proportionOfHeight (0.8061f)),
                                       true));
	g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.5000f), proportionOfWidth (0.5000f), proportionOfHeight (0.5000f));
	}
	if(color == 10) {
		// viper5
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xff003f5f),
                                       (float) (proportionOfWidth (0.5267f)), (float) (proportionOfHeight (0.1960f)),
                                       Colour (0xff4e89a7),
                                       (float) (proportionOfWidth (0.5267f)), (float) (proportionOfHeight (0.3553f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (0.5000f));
		g.setGradientFill (ColourGradient (Colour (0xff4e89a7),
                                       (float) (proportionOfWidth (0.5103f)), (float) (proportionOfHeight (0.7596f)),
                                       Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.5103f)), (float) (proportionOfHeight (0.8576f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.5000f), proportionOfWidth (1.0000f), proportionOfHeight (0.5000f));
	}
	if(color == 11) {
		// lava1
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colours::red,
                                       (float) (proportionOfWidth (0.0988f)), (float) (proportionOfHeight (0.1103f)),
                                       Colour (0xff030303),
                                       (float) (proportionOfWidth (0.1728f)), (float) (proportionOfHeight (0.2573f)),
                                       true));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
		g.setGradientFill (ColourGradient (Colours::red,
                                       (float) (proportionOfWidth (0.8807f)), (float) (proportionOfHeight (0.7718f)),
                                       Colour (0xff030303),
                                       (float) (proportionOfWidth (0.9218f)), (float) (proportionOfHeight (0.6003f)),
                                       true));
		g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
	}
	if(color == 12) {
		// lava2
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colours::red,
                                       (float) (proportionOfWidth (0.3621f)), (float) (proportionOfHeight (0.3430f)),
                                       Colour (0xff040404),
                                       (float) (proportionOfWidth (0.8230f)), (float) (proportionOfHeight (0.5513f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));
	}
	if(color == 13) {
		// lava3
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colours::red,
                                       (float) (proportionOfWidth (0.1235f)), (float) (proportionOfHeight (0.1715f)),
                                       Colour (0xff040404),
                                       (float) (proportionOfWidth (0.1564f)), (float) (proportionOfHeight (0.1593f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
		g.setGradientFill (ColourGradient (Colours::red,
                                       (float) (proportionOfWidth (0.9630f)), (float) (proportionOfHeight (0.3063f)),
                                       Colour (0xff040404),
                                       (float) (proportionOfWidth (0.8066f)), (float) (proportionOfHeight (0.3185f)),
                                       false));
		g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
	}
	if(color == 14) {
		// lava4
                g.fillAll (Colours::white);
                g.setGradientFill (ColourGradient (Colours::red,
                                       (float) (proportionOfWidth (0.0905f)), (float) (proportionOfHeight (0.5145f)),
                                       Colour (0xff030303),
                                       (float) (proportionOfWidth (0.1564f)), (float) (proportionOfHeight (0.5145f)),
                                       false));
                g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
                g.setGradientFill (ColourGradient (Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (1.0123f)), (float) (proportionOfHeight (0.4410f)),
                                       Colour (0xff030303),
                                       (float) (proportionOfWidth (0.8477f)), (float) (proportionOfHeight (0.4533f)),
                                       false));
                g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));

	}
	if(color == 15) {
		// lava5
                g.fillAll (Colours::white);
                g.setGradientFill (ColourGradient (Colours::red,
                                       (float) (proportionOfWidth (0.0988f)), (float) (proportionOfHeight (0.4165f)),
                                       Colour (0xff030303),
                                       (float) (proportionOfWidth (0.1728f)), (float) (proportionOfHeight (0.4165f)),
                                       false));
                g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
                g.setGradientFill (ColourGradient (Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.9053f)), (float) (proportionOfHeight (0.1348f)),
                                       Colour (0xff030303),
                                       (float) (proportionOfWidth (0.9136f)), (float) (proportionOfHeight (0.2818f)),
                                       true));
                g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
	}
	if(color == 16) {
		// classic1
                g.fillAll (Colours::black);

	}
	if(color == 17) {
		// classic2
                g.fillAll (Colours::silver);

	}
	if(color == 18) {
		// classic3
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xff030303),
                                       (float) (proportionOfWidth (0.0823f)), (float) (proportionOfHeight (0.5145f)),
                                       Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.1564f)), (float) (proportionOfHeight (0.5145f)),
                                       false));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));
	}
	if(color == 19) {
		// classic4
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.1317f)), (float) (proportionOfHeight (0.8208f)),
                                       Colour (0xff030303),
                                       (float) (proportionOfWidth (0.2140f)), (float) (proportionOfHeight (0.8453f)),
                                       true));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
		g.setGradientFill (ColourGradient (Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.6667f)), (float) (proportionOfHeight (0.1348f)),
                                       Colour (0xff030303),
                                       (float) (proportionOfWidth (0.6914f)), (float) (proportionOfHeight (0.2205f)),
                                       true));
		g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
	}
	if(color == 20) {
		// classic5
		g.fillAll (Colours::white);
		g.setGradientFill (ColourGradient (Colour (0xff030303),
                                       (float) (proportionOfWidth (0.0494f)), (float) (proportionOfHeight (0.0613f)),
                                       Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.1728f)), (float) (proportionOfHeight (0.6616f)),
                                       true));
		g.fillRect (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
		g.setGradientFill (ColourGradient (Colour (0xff030303),
                                       (float) (proportionOfWidth (0.9053f)), (float) (proportionOfHeight (0.1470f)),
                                       Colour (0xff9c9e97),
                                       (float) (proportionOfWidth (0.7737f)), (float) (proportionOfHeight (0.1715f)),
                                       true));
		g.fillRect (proportionOfWidth (0.5000f), proportionOfHeight (0.0000f), proportionOfWidth (0.5000f), proportionOfHeight (1.0000f));
	}

}

void ThemeComponent::resized(){

	textButtonApply->setBounds (proportionOfWidth (0.2881f), proportionOfHeight (0.9038f), proportionOfWidth (0.1543f), proportionOfHeight (0.0366f));
        textButtonClose->setBounds (proportionOfWidth (0.5350f), proportionOfHeight (0.9038f), proportionOfWidth (0.1543f), proportionOfHeight (0.0366f));

    imageButtonSipera1->setBounds (proportionOfWidth (0.1728f), proportionOfHeight (0.0490f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonSipera2->setBounds (proportionOfWidth (0.3457f), proportionOfHeight (0.0490f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonSipera3->setBounds (proportionOfWidth (0.5185f), proportionOfHeight (0.0490f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonSipera4->setBounds (proportionOfWidth (0.6831f), proportionOfHeight (0.0490f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonSipera5->setBounds (proportionOfWidth (0.8560f), proportionOfHeight (0.0490f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));

    imageButtonVIPER1->setBounds (proportionOfWidth (0.1728f), proportionOfHeight (0.2695f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonVIPER2->setBounds (proportionOfWidth (0.3457f), proportionOfHeight (0.2695f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonVIPER3->setBounds (proportionOfWidth (0.5185f), proportionOfHeight (0.2695f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonVIPER4->setBounds (proportionOfWidth (0.6831f), proportionOfHeight (0.2695f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonVIPER5->setBounds (proportionOfWidth (0.8560f), proportionOfHeight (0.2695f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));

    imageButtonLAVA1->setBounds (proportionOfWidth (0.1728f), proportionOfHeight (0.4900f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonLAVA2->setBounds (proportionOfWidth (0.3457f), proportionOfHeight (0.4900f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonLAVA3->setBounds (proportionOfWidth (0.5185f), proportionOfHeight (0.4900f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonLAVA4->setBounds (proportionOfWidth (0.6831f), proportionOfHeight (0.4900f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonLAVA5->setBounds (proportionOfWidth (0.8560f), proportionOfHeight (0.4900f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));

    imageButtonClassic1->setBounds (proportionOfWidth (0.1728f), proportionOfHeight (0.6983f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonClassic2->setBounds (proportionOfWidth (0.3457f), proportionOfHeight (0.6983f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonClassic3->setBounds (proportionOfWidth (0.5185f), proportionOfHeight (0.6983f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonClassic4->setBounds (proportionOfWidth (0.6831f), proportionOfHeight (0.6983f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));
    imageButtonClassic5->setBounds (proportionOfWidth (0.8560f), proportionOfHeight (0.6983f), proportionOfWidth (0.1183f), proportionOfHeight (0.1026f));

    labelSipera->setBounds (proportionOfWidth (0.0494f), proportionOfHeight (0.0858f), proportionOfWidth (0.1543f), proportionOfHeight (0.0367f));
    labelVIPER->setBounds (proportionOfWidth (0.0494f), proportionOfHeight (0.3063f), proportionOfWidth (0.1543f), proportionOfHeight (0.0367f));
    labelLAVA->setBounds (proportionOfWidth (0.0494f), proportionOfHeight (0.5268f), proportionOfWidth (0.1543f), proportionOfHeight (0.0367f));
    labelClassic->setBounds (proportionOfWidth (0.0494f), proportionOfHeight (0.7351f), proportionOfWidth (0.1543f), proportionOfHeight (0.0367f));

}

void ThemeComponent::buttonClicked (Button* buttonThatWasClicked)
{
	if (buttonThatWasClicked == textButtonApply) {
		// user selected 'Apply'
		setSkinBackgroundCC(color);
		myColor = color;
		compObjPtr->themeChanged();
	}
	if (buttonThatWasClicked == textButtonClose) {
		// user selected 'Close'
		fadeOutComponent(1000);
		delete colorWindow;

	}
	if (buttonThatWasClicked == imageButtonSipera1) {
		color = 1;
		newColor = T("sipera1");
		//printf("Color:  %s\n",newColor.toUTF8());
		repaint();
	}
	if (buttonThatWasClicked == imageButtonSipera2) {
		color = 2;
		newColor = T("sipera2");
		repaint();
	}
	if (buttonThatWasClicked == imageButtonSipera3) {
		color = 3;
		newColor = T("sipera3");
		repaint();
	}	
	if (buttonThatWasClicked == imageButtonSipera4) {
		color = 4;
		newColor = T("sipera4");
		repaint();
	}
	if (buttonThatWasClicked == imageButtonSipera5) {
		color = 5;
		newColor = T("sipera5");
		repaint();
	}
	if (buttonThatWasClicked == imageButtonVIPER1) {
		color = 6;
		newColor = T("viper1");
		repaint();
	}
	if (buttonThatWasClicked == imageButtonVIPER2) {
		color = 7;
		newColor = T("viper2");
		repaint();
	}
	if (buttonThatWasClicked == imageButtonVIPER3) {
                color = 8;
                newColor = T("viper3");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonVIPER4) {
		color = 9;
                newColor = T("viper4");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonVIPER5) {
		color = 10;
                newColor = T("viper5");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonLAVA1) {
                color = 11;
                newColor = T("lava1");
                repaint();

	}
	if (buttonThatWasClicked == imageButtonLAVA2) {
                color = 12;
                newColor = T("lava2");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonLAVA3) {
                color = 13;
                newColor = T("lava3");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonLAVA4) {
                color = 14;
                newColor = T("lava4");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonLAVA5) {
                color = 15;
                newColor = T("lava5");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonClassic1) {
                color = 16;
                newColor = T("classic1");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonClassic2) {
                color = 17;
                newColor = T("classic2");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonClassic3) {
                color = 18;
                newColor = T("classic3");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonClassic4) {
                color = 19;
                newColor = T("classic4");
                repaint();
	}
	if (buttonThatWasClicked == imageButtonClassic5) {
                color = 20;
                newColor = T("classic5");
                repaint();
	}
}
void ThemeComponent::themeChanged()
{

}
