#include "ToolbarWorker.h"
#include "ToolbarItemFactory.h"
#include "Toolbar.h"
#include "ThemeComponent.h"
#include "ColorWindow.h"
#include "ec_version.h"

ColorWindow* colorWindow;

ToolbarWorker::ToolbarWorker(void *ptr)
	: toolbar(0)
{
	compObjPtr = ptr;
	addAndMakeVisible(toolbar = new Toolbar());
	toolbar->addDefaultItems(factory);
	button1Info->addButtonListener(this);
	button1Info->setTooltip(T("Information Menu"));
}
ToolbarWorker::~ToolbarWorker()
{
	deleteAndZero(toolbar);

}

void ToolbarWorker::resized()
{

	toolbar->setBounds(0,0,getWidth(), 30);
	//toolbar->setBounds (proportionOfWidth (0.0000f), proportionOfHeight (0.0000f), proportionOfWidth (1.0000f), proportionOfHeight (0.0458f));

}

void ToolbarWorker::buttonClicked (Button* buttonThatWasClicked)
{

	if (buttonThatWasClicked == button1Info)
	{
	        PopupMenu m;
        	m.addItem (1, T("About UCSniff"));
        	m.addSeparator();
        	m.addItem (2, T("Themes"));

        	int result = m.show();

		if (result == 0) {

		} else if (result == 1) {

			// user picked 'About UCSniff'	
			String strECVersion = (char *)EC_VERSION;
			String strDisplayString = "UCSniff version " + strECVersion + "\n\nDeveloped by:  VIPER Lab, Avaya";
			AlertWindow::showMessageBox(AlertWindow::NoIcon, T("About UCSniff"),strDisplayString);
		} else if (result == 2) {
			colorWindow = new ColorWindow(compObjPtr);

		}

	}

}
