#include <targets.h>
#include <ec_siplog.h>

int decode_sip_header(unsigned char *);
int decode_from_uri(unsigned char *);
int decode_to_uri(unsigned char *);
int decode_callid(unsigned char *);
int decode_ua(unsigned char *);
int decode_cseq(unsigned char *);
int decode_kpml(unsigned char *);
int decode_media_port(unsigned char *);
int decode_video_port(unsigned char *);
int decode_dialed_ip(unsigned char *);
int checkreInviteHold(u_char *);
int getNegotiatedAudioCodecTypeAndRTPMAP(unsigned char*, char **, char *, char *, int *);
int getNegotiatedVideoCodecTypeAndRTPMAP(unsigned char*, char **, char **, char *, char *);

int decode_video_port(unsigned char *msg){

        char *result;
        char *end;
        char *sdp;

        SIPLOG("Inside decode_video_port\n");
        if((result = stristr(msg,"Content-Type:")) != NULL){

                SIPLOG("Found Content-Type header\n");
                if((end = strstr(result,"\r\n")) != NULL){

                        result = result + strlen("Content-Type:");
                        int length = end - result;
                        sdp = (char *)malloc((length+1) * sizeof(char));
                        memset(sdp,'\0',length+1);
                        strncpy(sdp,result,length);

                        char *temp;
                        SIPLOG("Content-Type header value is %s\n",sdp);
                        if((temp = strstr(sdp,"sdp")) != NULL ){
                                temp = NULL;
                                SIPLOG("Message has sdp message body\n");
                                if((temp = strstr(result,"m=video")) != NULL){

                                        SIPLOG("Found m=video in the sdp message body\n");
                                        temp = temp + strlen("m=video");
                                        char *var;
                                        if((var = strstr(temp,"RTP")) != NULL){

                                                SIPLOG("Found RTP value in the m=video line\n");
                                                int media_length = var - temp;
                                                char *src_port;
                                                src_port = (char *)malloc((media_length+1) * sizeof(char));
                                                memset(src_port,'\0',media_length+1);
                                                strncpy(src_port,temp,media_length);
                                                uri_obj.video_port = atoi(src_port);
                                                SIPLOG("Video port is %d\n",uri_obj.video_port);
						free(src_port);
                                                free(sdp);
                                                return 0;
                                        }
                                }
                        }
                        free(sdp);
                }
        }
return -1;
}

int decode_media_port(unsigned char *msg){

        char *result;
        char *end;
        char *sdp;

        //SIPLOG("Inside decode_media_port\n");
        if((result = stristr(msg,"Content-Type:")) != NULL){

                //SIPLOG("Found Content-Type header\n");
                if((end = strstr(result,"\r\n")) != NULL){

                        result = result + strlen("Content-Type:");
                        int length = end - result;
                        sdp = (char *)malloc((length+1) * sizeof(char));
                        memset(sdp,'\0',length+1);
                        strncpy(sdp,result,length);
                        //SIPLOG("Content-Type header is %s\n",sdp);
                        char *temp;
                        if((temp = strstr(sdp,"sdp")) != NULL){

                                //SIPLOG("Message has sdp message body\n");
                                temp = NULL;
                                if((temp = strstr(result,"m=audio")) != NULL){

                                        //SIPLOG("Found SDP message body m=audio\n");
                                        temp = temp + strlen("m=audio");
                                        char *var = NULL;
                                        if((var = strstr(temp,"RTP")) != NULL){

                                                //SIPLOG("Found RTP value in m=audio line\n");
                                                int media_length = var - temp;
                                                char *src_port;
                                                src_port = (char *)malloc((media_length+1)*sizeof(char));
                                                memset(src_port,'\0',media_length+1);
                                                strncpy(src_port,temp,media_length);

                                                uri_obj.media_src_port = atoi(src_port);
						//SIPLOG("Media port is %d\n",uri_obj.media_src_port);
                                                free(sdp);
                                                free(src_port);
                                                return 0;
                                        }
                                }
                        }
                        free(sdp);
                }
        }
return -1;
}

int decode_dialed_ip(unsigned char *msg){

        char *result;
        char *end;
        char *sdp;

        //SIPLOG("Inside decode_dialed_ip\n");
        if((result = stristr(msg,"Content-Type:")) != NULL){

                //SIPLOG("Found Content-Type header\n");
                if((end = strstr(result,"\r\n")) != NULL){
                        //SIPLOG("Parsed the end of Content-Type header\n");
                        result = result + strlen("Content-Type:");
                        int length = end - result;
                        sdp = (char *) malloc ((length+1) * sizeof(char));
                        memset(sdp,'\0',length+1);
                        strncpy(sdp,result,length);
                        //SIPLOG("Content-Type header is %s\n",sdp);
                        char *temp;
                        if((temp = strstr(sdp,"sdp")) != NULL){

                                //SIPLOG("The message has sdp\n");
                                temp = NULL;
                                if((temp = strstr(result,"c=IN IP4 ")) != NULL){

                                        //SIPLOG("Found connection info in RTP\n");
                                        temp = temp + strlen("c=IN IP4 ");
                                        char *var;
                                        if((var = strstr(temp,"\r\n")) != NULL){

                                                //SIPLOG("Found end of connection info\n");
                                                int ip_length = var - temp;
                                                char ip_addr[MAX_ASCII_ADDR_LEN];
                                                //ip_addr = (char *)malloc(ip_length * sizeof(char));
                                                memset(ip_addr,'\0',sizeof(ip_addr));
                                                //ip_addr[ip_length] = '\0';
                                                if(ip_length >= MAX_ASCII_ADDR_LEN)
                                                        ip_length = MAX_ASCII_ADDR_LEN-1;
						strncpy(ip_addr, temp, ip_length);
                                                memset(uri_obj.ip_addr,'\0',sizeof(uri_obj.ip_addr));
                                                memcpy(uri_obj.ip_addr, ip_addr, sizeof(uri_obj.ip_addr));
                                                //SIPLOG("Connection info IP address is %s\n",uri_obj.ip_addr);
                                                free(sdp);
                                                return 0;
                                        }
                                }
                        }
                }
        }
        return -1;
}

int checkreInviteHold(u_char * msg){

        //SIPLOG("Inside checkreInviteHold\n");
        if(!strcmp(uri_obj.ip_addr,"0.0.0.0"))
                return 1;

        char *result;
        char *end;
        char *sdp;

        if((result = stristr(msg,"Content-Type:")) != NULL){

                //SIPLOG("Found Content-Type header\n");
                if((end = strstr(result,"\r\n")) != NULL){
                        result = result + strlen("Content-Type:");
                        int length = end - result;
                        sdp = (char *)malloc((length + 1) * sizeof(char));
                        memset(sdp,'\0',length + 1);
                        strncpy(sdp, result, length);
                        char * temp;
                        //SIPLOG("Content-Type header is %s\n",sdp);
                        if((temp = strstr(sdp,"sdp")) != NULL){
                                //SIPLOG("Message has sdp message body\n");
                                temp = NULL;
                                if((temp = strstr(result,"a=sendonly")) != NULL){
                                        //SIPLOG("Found a=sendonly in the sdp message body\n");
                                        free(sdp);
                                        return 1;
                                }
                        }
                        free(sdp);
                }
        }
        return -1;
}

int decode_kpml(unsigned char *msg){

        char *result;
        char *end;

        //SIPLOG("Inside decode_kpml\n");
        if((result = stristr(msg,"Allow-Events:")) != NULL){

                if((end = strstr(result,"kpml")) != NULL){

                        //SIPLOG("KPML is enabled, uri_obj.kpml_enabled= %d\n",uri_obj.kpml_enabled);
                        uri_obj.kpml_enabled = 1;
                        return 0;
                }
        }
        return -1;
}

int decode_cseq(unsigned char *msg){

        char *result;
        char *end;
        //char temp[48] = {'\0'};
        //char tmp[48] = {'\0'};
        char *temp = NULL;
        char *tmp = NULL;

        //SIPLOG("Inside decode_cseq\n");
        uri_obj.cseq = 0;
        memset(uri_obj.cseq_method,'\0',sizeof(uri_obj.cseq_method));
        if(((result = stristr(msg,"CSeq:")) != NULL)){

                //SIPLOG("Found CSeq header\n");
                if((end = strstr(result,"\r\n")) != NULL){
                        //SIPLOG("Parsed the end of CSeq\n");
                        result = result + strlen("CSeq:");
                        while(*result == ' '){
                                result = result + 1;
                        }
                        int length = end - result;
                        temp = (char *)malloc((length+1)*sizeof(char));
                        memset(temp,'\0',length+1);
                        memcpy(temp,result,length);
                        //SIPLOG("CSeq header is %s\n",temp);
                        result = NULL;
                        if((result = strstr(temp," ")) != NULL){
                                /* Copy CSeq number */
                                int len = result - temp;
                                tmp = (char*)malloc((len+1)*sizeof(char));
                                memset(tmp,'\0',len+1);
                                memcpy(tmp,temp,len);
                                uri_obj.cseq = atoi(tmp);
                                //SIPLOG("CSeq number is %d\n",uri_obj.cseq);
                                /* Copy CSeq method */
                                ++result;
                                memcpy(uri_obj.cseq_method,result,sizeof(uri_obj.cseq_method)-1);
				//SIPLOG("CSeq method is %s\n",uri_obj.cseq_method);
                                free(tmp);
                                return 0;
                        }
                        free(temp);
                }
        }
        return -1;
}

int decode_ua(unsigned char *msg){

        char *result;
        char *end;

        //SIPLOG("Inside decode_ua\n");
        bzero(uri_obj.phone_type,sizeof(uri_obj.phone_type));
        if((result = stristr(msg,"User-Agent:")) != NULL){

                //SIPLOG("Found User-Agent header\n");
                result = result + strlen("User-Agent:");
                while(*result == ' '){
                        result = result + 1;
                }
                if((end = strstr(result,"\r\n")) != NULL){
                        //SIPLOG("Parsed the line end of User-Agent header\n");
                        int length = end - result;
                        if(length >= sizeof(uri_obj.phone_type))
                                length = sizeof(uri_obj.phone_type) - 1;
                        strncpy(uri_obj.phone_type,result,length);
                        //SIPLOG("User-Agent header is %s\n",uri_obj.phone_type);
                        return 0;
                }
        }
return -1;
}

int decode_remote_party(unsigned char *msg){

        char *result = NULL;
        char *extension = NULL;
        char *tmp = NULL;
        char temp[256] = {'\0'};
        int i = 0;

        memset(uri_obj.dst_extension,'\0',sizeof(uri_obj.dst_extension));
        memset(uri_obj.to_uri,'\0',sizeof(uri_obj.to_uri));
        if((result = stristr(msg,"Remote-Party-ID:")) != NULL){

                result = result + strlen("Remote-Party-ID:");
                if((tmp = strstr(result,"\r\n")) != NULL){
                        int length = tmp - result;
                        tmp  = NULL;
                        tmp = (char *)calloc(length + 1,sizeof(char));
                        if(tmp == NULL)
                                return -1;
                        memset(tmp,'\0',length+1);
                        memcpy(tmp,result,length);

                        if((result = strstr(tmp,"<sip:")) != NULL){

                                result = result + strlen("<sip:");

                                //while(*result != '>' && *result != ';'){
                                while(1){

                                        if(*result == '>' || *result == ';' || *result == ':' || *result == '\0' || i == (sizeof(uri_obj.to_uri)-1))
                                                break;
                                       uri_obj.to_uri[i] = *result;
                                        ++result;
                                        ++i;
                                }
                                strncpy(temp,uri_obj.to_uri,sizeof(temp));
                                ec_strtok(temp,"@",&extension);
                                strncpy(uri_obj.dst_extension,temp,sizeof(uri_obj.dst_extension)-1);
				free(tmp);
                                return 0;
                        }
                        else if((result = strstr(tmp,"sip:")) != NULL){

                                result = result + strlen("sip:");

                                //while(*result != ';' && *result != '\n'){
                                while(1){

                                        if(*result == ';' || *result == '\0' || *result == ':' || i == (sizeof(uri_obj.to_uri)-1))
                                                break;

                                        uri_obj.to_uri[i] = *result;
                                        ++result;
                                     ++i;
                                }
                                strncpy(temp,uri_obj.to_uri,sizeof(temp));
                                ec_strtok((u_char *)temp,"@",&extension);
                                strncpy(uri_obj.dst_extension,temp,sizeof(uri_obj.dst_extension)-1);
                                free(tmp);
                                return 0;
                        }
                }
        }
        return -1;
}

int decode_to_uri(unsigned char *msg){

        char *result = NULL;
        char *extension = NULL;
        char *tmp = NULL;
        char temp[256] = {'\0'};
        int i = 0;

        //SIPLOG("Inside decode_to_uri\n");
        memset(uri_obj.dst_extension,'\0',sizeof(uri_obj.dst_extension));
        memset(uri_obj.to_uri,'\0',sizeof(uri_obj.to_uri));
        if((result = stristr(msg,"To:")) != NULL){

                //SIPLOG("Found To header\n");
                result = result + strlen("To:");
                if((tmp = strstr(result,"\r\n")) != NULL){

                        //SIPLOG("Parsed the end of To header\n");

                        int length = tmp - result;
                        tmp  = NULL;
                        tmp = (char *)calloc(length + 1,sizeof(char));
                        if(tmp == NULL)
                                return -1;
                        memset(tmp,'\0',length+1);
                        memcpy(tmp,result,length);
						/* Parses the to-tag */
						char *ttag = NULL;
                        if((ttag = strstr(tmp,";tag=")) != NULL){
                            ttag += strlen(";tag=");
                            strncpy(uri_obj.to_tag,ttag,sizeof(uri_obj.to_tag)-1);
                        }
                        //SIPLOG("To header value is %s\n",tmp);
                        if((result = strstr(tmp,"<sip:")) != NULL){

                                //SIPLOG("Found <sip: tag in To header\n");
                                result = result + strlen("<sip:");

                               //while((*result != '>') && (*result != ';') && (*result != '\0') && (*result != ':')){
                                while(1){

                                        if(*result == '>' || *result == ';' || *result == '\0' || *result == ':' || i == (sizeof(uri_obj.to_uri)-1))
                                                break;
					uri_obj.to_uri[i] = *result;
                                        ++result;
                                        ++i;
                                }
                                //SIPLOG("To-uri is %s\n",uri_obj.to_uri);
                                strncpy(temp,uri_obj.to_uri,sizeof(temp));
                                ec_strtok(temp,"@",&extension);
                                strncpy(uri_obj.dst_extension,temp,sizeof(uri_obj.dst_extension)-1);
                                //SIPLOG("To-extension is %s\n",uri_obj.dst_extension);
                                free(tmp);
                                return 0;
                        }

                        else if((result = strstr(tmp,"sip:")) != NULL){

                                //SIPLOG("Found sip: tag in To header\n");
                                result = result + strlen("sip:");

                                //while((*result != ';') && (*result != '\0') && (*result != ':')){
                                while(1){

                                        if(*result == ';' || *result == '\0' || *result == ':' || i == (sizeof(uri_obj.to_uri)-1))
                                                break;

                                        uri_obj.to_uri[i] = *result;
                                        ++result;
                                     ++i;
                                }
                                //SIPLOG("To-uri is %s\n",uri_obj.to_uri);
                                strncpy(temp,uri_obj.to_uri,sizeof(temp));
                                ec_strtok((u_char *)temp,"@",&extension);
                                strncpy(uri_obj.dst_extension,temp,sizeof(uri_obj.dst_extension)-1);
                                //SIPLOG("To-extension is %s\n",uri_obj.dst_extension);
                                free(tmp);
                                return 0;
                        }
                }
        }

	return -1;
}


int decode_from_uri(unsigned char * msg){

        //SIPLOG("Inside decode_from_uri\n");

        char *result = NULL;
        char *extension = NULL;
        char *tmp = NULL;
        char temp[256] = {'\0'};
        int i = 0;

        memset(uri_obj.from_uri,'\0',sizeof(uri_obj.from_uri));
        memset(uri_obj.src_extension,'\0',sizeof(uri_obj.src_extension));
        if((result = stristr(msg,"From:")) != NULL){

                //SIPLOG("Found From header\n");
                result = result + strlen("From:");
                if((tmp = strstr(result,"\r\n")) != NULL){
                        //SIPLOG("Parsed the end of From header line\n");
                        int length = tmp - result;
                        tmp  = NULL;
                        tmp = (char *)malloc((length + 1)*sizeof(char));
                        if(tmp == NULL)
                                return -1;
                        memset(tmp,'\0',length+1);
                        memcpy(tmp,result,length);
                        //SIPLOG("FROM header value is %s\n",tmp);
						/* Parses the from-tag */
						char *ftag = NULL;
						if((ftag = strstr(tmp,";tag=")) != NULL){
							ftag += strlen(";tag=");
							strncpy(uri_obj.from_tag,ftag,sizeof(uri_obj.from_tag)-1);
						}
                        if((result = strstr(tmp,"<sip:")) != NULL){

				//SIPLOG("Found <sip:tag in FROM header\n");
                                result = result + strlen("<sip:");
                                //while((*result != '>') && (*result != ';') && (*result != '\0') && (*result != ':')){
                                while(1){

                                        if(*result == '>' || *result == ';' || *result == '\0' || *result == ':' || i == (sizeof(uri_obj.from_uri)-1))
                                                break;

                                        uri_obj.from_uri[i] = *result;
                                        ++result; ++i;
                                }

                                strncpy(temp,uri_obj.from_uri,sizeof(temp));
                                //SIPLOG("From-URI is %s\n",uri_obj.from_uri);
                                ec_strtok((u_char *)temp,"@",&extension);
                                strncpy(uri_obj.src_extension,temp,sizeof(uri_obj.src_extension)-1);
                                //SIPLOG("From-extension value is %s\n",uri_obj.src_extension);
                                free(tmp);
                                return 0;
                        }

                        else if((result = strstr(tmp,"sip:")) != NULL){

                                //SIPLOG("Found sip: tag in FROM header\n");
                                result = result + strlen("sip:");
                                //while((*result != ';') && (*result != '\0') && (*result != ':')){
                                while(1){

                                        if(*result == ';' || *result == '\0' || *result == ':' || i == (sizeof(uri_obj.from_uri)-1))
                                                break;

                                        uri_obj.from_uri[i] = *result;
                                        ++result; ++i;
                                }

                                //SIPLOG("From-URI is %s\n",uri_obj.from_uri);
                                strncpy(temp,uri_obj.from_uri,sizeof(temp));
                                ec_strtok((u_char *)temp,"@",&extension);
				strncpy(uri_obj.src_extension,temp,sizeof(uri_obj.src_extension)-1);
                                //SIPLOG("From-extension value is %s\n",uri_obj.src_extension);
                                free(tmp);
                                return 0;
                        }
                }
        }
        return -1;
}

int decode_callid(unsigned char *msg){

        char *result, *tmp;

        //SIPLOG("Inside decode_callid\n");
        memset(uri_obj.call_id,'\0',sizeof(uri_obj.call_id));
        if(((result = stristr(msg,"Call-ID:")) != NULL)){
                //SIPLOG("Foung Call-ID header\n");
                result = result + strlen("Call-ID:");
                while(*result == ' '){
                   result = result + 1;
                }
                if((tmp = strstr(result,"\r\n")) != NULL){
                        //SIPLOG("Parsed the end of Call-ID\n");
                        int length = tmp - result;
                        if(length > (sizeof(uri_obj.call_id) - 1))
                                length = sizeof(uri_obj.call_id) - 1;
                        strncpy(uri_obj.call_id,result,length);
                        //SIPLOG("Call-ID is %s\n",uri_obj.call_id);
                        return 0;
                }
        }
        return -1;
}

int decode_sip_header(unsigned char *ptr){

        //SIPLOG("Inside decode_sip_header\n");

        int return_from = decode_from_uri(ptr);
        if(return_from < 0){
                SIPLOG("Failed: parsing from-uri\n");
                return -1;
        }

        int return_to = decode_to_uri(ptr);
        if(return_to < 0){
                SIPLOG("Failed: parsing to-uri\n");
                return -1;
        }

        int return_callid = decode_callid(ptr);
        if(return_callid < 0){
                SIPLOG("Failed: parsing call-id\n");
                return -1;
        }

        int return_cseq = decode_cseq(ptr);
        if(return_cseq < 0){
                SIPLOG("Failed: parsing cseq\n");
                return -1;
        }

        /* int return_fromtag = decode_from_tag(ptr);
        if(return_fromtag < 0)
                return -1;

        */

        return 0;
}

int getNegotiatedAudioCodecTypeAndRTPMAP(unsigned char *msg, char **rtpmap, char *audioCodecType, char *audioPayloadType, int *g726SampleSize){

	char *ptr = NULL;
	char *end = NULL;
	char *mediaString = NULL;

	if((ptr = strstr(msg,"m=audio")) != NULL){

		if((end = strstr(ptr,"\r\n")) != NULL){

			int length = end - ptr;

			mediaString = (char *) calloc(length + 1, sizeof(char));
			if(mediaString == NULL){
				printf("Error: Allocating new memory for mediaString \n");
				return -1;
			}

			strncpy(mediaString,ptr,length);
			if((ptr = strstr(mediaString,"RTP/AVP")) != NULL){

				ptr = ptr + strlen("RTP/AVP") + 1; /* 1 is for the space succeding RTP/AVP */
				if(((end = strstr(ptr," ")) != NULL) || ((end = strstr(ptr,"\0"))) != NULL){
					
					if(ptr == end){
						length = strlen(ptr);
					}
					else{
						length = end - ptr;
					}
					char *rtpString = (char *) calloc(length + 1, sizeof(char));
			    	if(rtpString == NULL){
						printf("Error: Allocating new memory for rtpString\n");
				    	return -1;
			    	}

					strncpy(rtpString,ptr,length);

					int codecInt = atoi(rtpString);
					//*audioPayloadType = (char)codecInt;
			
					char *temprtpmap = (char *) calloc(strlen("a=rtpmap:") + strlen(rtpString) + 1, sizeof(char));
					if(temprtpmap == NULL){
						printf("Error: Allocating new memory for temprtpmap \n");
						return -1;
					}

					strncpy(temprtpmap, "a=rtpmap:", strlen("a=rtpmap:"));
					strcat(temprtpmap,rtpString);
					free(rtpString);

					if((ptr = strstr(msg,temprtpmap)) != NULL){

						if((end = strstr(ptr,"\r\n")) != NULL){

							length = end - ptr;
							char *temprtpmapString = (char *) calloc(length + 1, sizeof(char));
							if(temprtpmapString == NULL){
								printf("Error: Allocating new memory of temprtpmapString \n");
								return -1;
							}
							strncpy(temprtpmapString,ptr,length);

							char *searchPtr = NULL;
							if((searchPtr = stristr(temprtpmapString,"G722/8000")) != NULL){
				
								*audioPayloadType = (char)codecInt;		
								*audioCodecType = COG722;
							}
							else if((searchPtr = stristr(temprtpmapString,"PCMU/8000")) != NULL){
	
								*audioPayloadType = (char)codecInt;		
								*audioCodecType = COG711MULAW;
							}
							else if((searchPtr = stristr(temprtpmapString,"PCMA/8000")) != NULL){

								*audioPayloadType = (char)codecInt;	
								*audioCodecType = COG711ALAW;
							}
							else if((searchPtr = stristr(temprtpmapString,"G729/8000")) != NULL){
								*audioPayloadType = (char)codecInt;
                            	*audioCodecType = COG729;
							}
							else if((searchPtr = stristr(temprtpmapString,"G723/8000")) != NULL){
        	                    *audioPayloadType = (char)codecInt;
    	                        *audioCodecType = COG723;
            	            }
							else if((searchPtr = stristr(temprtpmapString,"G726-32/8000")) != NULL){
								*audioPayloadType = (char)codecInt;
								*audioCodecType = COG726;
								*g726SampleSize = 4;
							}
							else if((searchPtr = stristr(temprtpmapString,"G726-16/8000")) != NULL){
								*audioPayloadType = (char)codecInt;
								*audioCodecType = COG726;
								*g726SampleSize = 2;
							}
							else if((searchPtr = stristr(temprtpmapString,"G726-24/8000")) != NULL){
    	                        *audioPayloadType = (char)codecInt;
        	                    *audioCodecType = COG726;
								*g726SampleSize = 3;
                	        }
							else if((searchPtr = stristr(temprtpmapString,"G726-40/8000")) != NULL){
    	                        *audioPayloadType = (char)codecInt;
        	                    *audioCodecType = COG726;
								*g726SampleSize = 5;
                	        }
							else{
								free(temprtpmap);
								free(temprtpmapString);
								return -1;
							}
						
							*rtpmap = (char *)calloc(length + 1, sizeof(char));
							if(*rtpmap == NULL){
								printf("Error: Allocating new memory for rtpmap \n");
								return -1;
							}
							strncpy(*rtpmap,temprtpmapString,length);

							free(temprtpmapString);
							free(temprtpmap);
							return 0;
						}
					}
				}
			}
		}
	}
	return -1;
}

int getNegotiatedVideoCodecTypeAndRTPMAP(unsigned char *msg, char **vrtpmap, char **vfmtp, char *videoCodecType, char *videoPayloadType){

	char *ptr = NULL;
    char *end = NULL;
	char *mediaString = NULL;

    if((ptr = strstr(msg,"m=video")) != NULL){

		if((end = strstr(ptr,"\r\n")) != NULL){

            int length = end - ptr;

            mediaString = (char *) calloc(length + 1, sizeof(char));
            if(mediaString == NULL){
                printf("Error: Allocating new memory for mediaString \n");
                return -1;
            }

            strncpy(mediaString,ptr,length);


 	       if((ptr = strstr(mediaString,"RTP/AVP")) != NULL){

    	   		ptr = ptr + strlen("RTP/AVP") + 1; /* 1 is for the space succeding RTP/AVP */

            	if(((end = strstr(ptr," ")) != NULL)  || ((end = strstr(ptr,"\0"))!=NULL)){

					if(ptr == end){
						length = strlen(ptr);
					}else{	
                		length = end - ptr;
					}
                	char *rtpString = (char *) calloc(length + 1, sizeof(char));
                	if(rtpString == NULL){
                    	printf("Error: Allocating new memory for rtpString\n");
                    	return -1;
                	}

	                strncpy(rtpString,ptr,length);
    	            int codecInt = atoi(rtpString);
            	    //*videoPayloadType = (char)codecInt;
	
    	            char *temprtpmap = (char *) calloc(strlen("a=rtpmap:") + strlen(rtpString) + 1, sizeof(char));
        	        if(temprtpmap == NULL){
            	        printf("Error: Allocating new memory for temprtpmap \n");
                	    return -1;
                	}	

	                strncpy(temprtpmap, "a=rtpmap:", strlen("a=rtpmap:"));
	                strcat(temprtpmap,rtpString);

        	        if((ptr = strstr(msg,temprtpmap)) != NULL){

            	        if((end = strstr(ptr,"\r\n")) != NULL){
					
							length = end - ptr;
                        	char *temprtpmapString = (char *) calloc(length + 1, sizeof(char));
                    	    if(temprtpmapString == NULL){
                            	printf("Error: Allocating new memory of temprtpmapString \n");
                            	return -1;
	                        }
    	                    strncpy(temprtpmapString,ptr,length);
	
        	                char *searchPtr = NULL;
            	            if((searchPtr = stristr(temprtpmapString,"H264")) != NULL){
	
								*videoPayloadType = (char)codecInt;
								*videoCodecType = COH264;
                	        }
							else{
								return -1;
							}

							char *tempfmtp = (char *) calloc(strlen("a=fmtp:") + strlen(rtpString) + 1,sizeof(char));
							if(tempfmtp == NULL){
								printf("Error: Allocating new memory for tempfmtp\n");
								return -1;
							}
							strncpy(tempfmtp,"a=fmtp:",strlen("a=fmtp:"));
							strcat(tempfmtp,rtpString);
							free(rtpString);

							*vrtpmap = (char *)calloc(length + 1,sizeof(char));
							if(*vrtpmap == NULL){
								printf("Error: Allocating new memory for vrtpmap\n");
								return -1;
							}
							strncpy(*vrtpmap,temprtpmapString,length); 

							if((ptr = strstr(msg,tempfmtp))	!= NULL){
						
								if((end = strstr(ptr,"\r\n")) != NULL){

									length = end - ptr;
									char *tempfmtpString = (char *)calloc(length + 1, sizeof(char));
									if(tempfmtpString == NULL){
										printf("Error: Allocating new memory for tempfmtpString\n");
										return -1;
									}
									strncpy(tempfmtpString,ptr,length);
							
									*vfmtp = (char *)calloc(length + 1, sizeof(char));
									if(*vfmtp == NULL){
										printf("Error: Allocating new memory for vfmtp\n");
										return -1;
									}
									strncpy(*vfmtp,tempfmtpString,length);
									free(tempfmtpString);
								}
							}

							free(temprtpmapString);
                        	free(temprtpmap);
							free(tempfmtp);
                        	return 0;
                    	}
	                }
    	        }
        	}
    	}
	}
	return -1;
}

