#include <targets.h>
#include <ec_siplog.h>
#include <stdarg.h>
#include <ec_voipglobals.h>
#include <ec_voiplogfiles.h>

/* Variable for file log error check */
int logcheck=1;   /* If value=1, logging works */

void printtocalllog(sipDB*,int);
void printtocalldetaillog(sipDB *);
void printtoSipLog(sipDB *, rtpSIP *, char *);
void siplogging(const char *fmt, ...);
void siprtplogging(const char *fmt, ...);

void printtocalllog(sipDB *currentSipCall,int start_end){

        int ret = 0;

        if(!logcheck)
                return;

        if(start_end == 1){

        if((ret = fprintf(ofile,"SIP Call %d: ",currentSipCall->call_number)) < 0){
                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                logcheck=0;
                return;
        }
        fflush(ofile);
        if(strlen(currentSipCall->src_username) == 0){
                if((ret = fprintf(ofile,"(extension %s, ip %s) calling to ",currentSipCall->src_extension,currentSipCall->media_src_ip)) < 0){
                        INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                        SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                        logcheck=0;
                        return;
                }
                fflush(ofile);
        }
        else{
                if((ret = fprintf(ofile,"%s (extension %s, ip %s) calling to ",currentSipCall->src_username,currentSipCall->src_extension,currentSipCall->media_src_ip)) < 0){
                        INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                        SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                        logcheck=0;
                        return;
                }
                fflush(ofile);
        }

        if(strlen(currentSipCall->dst_username) == 0){
                if(currentSipCall->remoteParty){
			if((ret = fprintf(ofile, "(extension %s, ip %s), RTP port %d \n",currentSipCall->remote_extension,currentSipCall->dst_ip,currentSipCall->media_src_port)) < 0){
                                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                                logcheck=0;
                                return;
                        }
                }
                else{
                        if((ret = fprintf(ofile, "(extension %s, ip %s), RTP port %d \n",currentSipCall->dst_extension,currentSipCall->dst_ip,currentSipCall->media_src_port)) < 0){
                                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                                logcheck=0;
                                return;
                        }
                }
                fflush(ofile);
        }
        else{
                if(currentSipCall->remoteParty){
                        if((ret = fprintf(ofile, "%s (extension %s, ip %s), RTP port %d \n", currentSipCall->dst_username,currentSipCall->remote_extension,currentSipCall->dst_ip,currentSipCall->media_src_port)) < 0){
                                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                                logcheck=0;
                                return;
                        }
                }
                else{
                        if((ret = fprintf(ofile, "%s (extension %s, ip %s), RTP port %d \n", currentSipCall->dst_username,currentSipCall->dst_extension,currentSipCall->dst_ip,currentSipCall->media_src_port)) < 0){
                                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                                logcheck=0;
                                return;
                        }
		}
                fflush(ofile);
        }

        }
        else if(start_end == 2){

                char time_string[12];
                get_time_string(1,time_string);

                if((ret = fprintf(ofile,"SIP Call %d: ended at %s. Call duration is %d \n ",currentSipCall->call_number,time_string,currentSipCall->finish.tv_sec - currentSipCall->start.tv_sec)) < 0){
                        INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                        SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                        logcheck=0;
                        return;
                }
                fflush(ofile);
        }
}

void printtocalldetaillog(sipDB* currentSipCall){

        int ret = 0;
        if(!logcheck)
                return;

        if((ret = fprintf(odetailfile,"SIP Call %d: ",currentSipCall->call_number)) < 0){
                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                logcheck=0;
                return;
        }
        fflush(odetailfile);
        if(strlen(currentSipCall->src_username) == 0){
                if((ret = fprintf(odetailfile,"(extension %s, ip %s) calling to ",currentSipCall->src_extension,currentSipCall->media_src_ip)) < 0){
                        INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                        SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                        logcheck=0;
                        return;
                }
                fflush(odetailfile);
        }
        else{
                if((ret = fprintf(odetailfile,"%s (extension %s, ip %s) calling to ",currentSipCall->src_username,currentSipCall->src_extension,currentSipCall->media_src_ip)) < 0){
                        INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                        SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                        logcheck=0;
                        return;
                }
                fflush(odetailfile);
        }
	if(strlen(currentSipCall->dst_username) == 0){
                if(currentSipCall->remoteParty){
                        if((ret = fprintf(odetailfile, "(extension %s, ip %s), at %s.",currentSipCall->remote_extension,currentSipCall->dst_ip,currentSipCall->start_time_string)) < 0){
                                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                                logcheck=0;
                                return;
                        }
                }
                else{
                        if((ret = fprintf(odetailfile, "(extension %s, ip %s), at %s.",currentSipCall->dst_extension,currentSipCall->dst_ip,currentSipCall->start_time_string)) < 0){
                                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                                logcheck=0;
                                return;
                        }
                }
                fflush(odetailfile);
        }
	else{
                if(currentSipCall->remoteParty){
                        if((ret = fprintf(odetailfile, "%s (extension %s, ip %s), at %s.",currentSipCall->dst_username,currentSipCall->remote_extension,currentSipCall->dst_ip,currentSipCall->start_time_string)) < 0){
                                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                                logcheck=0;
                                return;
                        }
                }
                else{
                        if((ret = fprintf(odetailfile,"%s (extension %s, ip %s), at %s.",currentSipCall->dst_username,currentSipCall->dst_extension,currentSipCall->dst_ip,currentSipCall->start_time_string)) < 0){
                                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                                logcheck=0;
                                return;
                        }
                }
                fflush(odetailfile);
        }
        if((ret = fprintf(odetailfile,"Call ended at %s. Duration : %d \n",currentSipCall->end_time_string,currentSipCall->finish.tv_sec - currentSipCall->start.tv_sec)) < 0){
                INSTANT_USER_MSG("Error: Logging sip call details, %s\n",strerror(errno));
                SIPLOG("Error: Logging sip call details, %s\n",strerror(errno));
                logcheck=0;
                return;
        }
        fflush(odetailfile);
}

void printtoSipLog(sipDB* currentSipCall, rtpSIP* currentRTPCall, char* method){

        if(sipfile != NULL){

                SIPLOG("UCSniff: SIP message log\n\n");
                SIPLOG("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ %s Received @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ \n",method);
                SIPLOG("source ip = %s;source port = %d\n",currentSipCall->src_ip,currentSipCall->src_port);
                SIPLOG("destination ip = %s;destination port = %d\n",currentSipCall->dst_ip,currentSipCall->dst_port);
                SIPLOG("source extension = %s;destination extension = %s\n",currentSipCall->src_extension,currentSipCall->dst_extension);
                SIPLOG("Remote extension = %s; Remote Party flag = %d\n",currentSipCall->remote_extension,currentSipCall->remoteParty);
                SIPLOG("call id = %s;cseq = %d\n",currentSipCall->call_id,currentSipCall->cseq);
                SIPLOG("user agent = %s\n",currentSipCall->user_agent);
                SIPLOG("RTP media port, source port = %d;destination port = %d \n",currentSipCall->media_src_port,currentSipCall->media_dst_port);
                SIPLOG("RTP media ip, source ip = %s;destination ip = %s \n",currentSipCall->media_src_ip,currentSipCall->media_dst_ip);
                SIPLOG("RTP video port, source port = %d;destination port = %d\n",currentSipCall->video_src_port,currentSipCall->video_dst_port);
                SIPLOG("source username = %s;destination username = %s\n",currentSipCall->src_username,currentSipCall->dst_username);
                SIPLOG("call number = %d\n",currentSipCall->call_number);
                SIPLOG("kpml value = %d\n",currentSipCall->kpml_enabled);
                SIPLOG("invite_active = %d;okay_active = %d;ack_active = %d;session_active = %d\n",currentSipCall->invite_active,currentSipCall->okay_active,currentSipCall->ack_active,currentSipCall->session_active);
                SIPLOG("diff_vlan value = %d;video active = %d\n",currentSipCall->diff_vlan,currentSipCall->video_active);
                SIPLOG("server_reinvite = %d;server_reinviteNoSDP = %d\n",currentSipCall->server_reinvite,currentSipCall->server_reinviteNoSDP);
                SIPLOG("server_reinviteOkay = %d;server_reinviteAck = %d;server_reinviteCSeq = %d \n",currentSipCall->server_reinviteOkay,currentSipCall->server_reinviteAck,currentSipCall->server_reinviteCSeq);
                SIPLOG("client_reinvite = %d;client_reinviteNoSDP = %d\n",currentSipCall->client_reinvite,currentSipCall->client_reinviteNoSDP);
                SIPLOG("client_reinviteOkay = %d;client_reinviteAck = %d;client_reinviteCSeq = %d \n",currentSipCall->client_reinviteOkay,currentSipCall->client_reinviteAck,currentSipCall->client_reinviteCSeq);

                if(currentRTPCall != NULL){

			SIPLOG("########### RTP Value logs ##########\n");
                        SIPLOG("videoport = %d\n",currentRTPCall->vport);
                        SIPLOG("vfwd_count = %d;vrev_count = %d;vrtp_count = %d\n",currentRTPCall->vfwd_count,currentRTPCall->vrev_count,currentRTPCall->vrtp_count);
                        SIPLOG("vfwd_seqCount = %d;vrev_seqCount = %d\n",currentRTPCall->vfwd_seqcount,currentRTPCall->vrev_seqcount);
                        SIPLOG("vfwd_file = %s;vrev_file = %s;vfwd_mp4 = %s;vrev_mp4 = %s;vfwd_avi = %s;vrev_avi = %s\n",currentRTPCall->vfwd_file,currentRTPCall->vrev_file,currentRTPCall->vfwd_mp4,currentRTPCall->vrev_mp4,currentRTPCall->vfwd_avi,currentRTPCall->vrev_avi);
                        SIPLOG("RTP ip address = %s; port = %d\n",currentRTPCall->ip_addr,currentRTPCall->port);
                        SIPLOG("session active = %d\n",currentRTPCall->session_active);
                        SIPLOG("fwd_wav = %s;rev_wav = %s;both_wav = %s\n",currentRTPCall->fwd_wav,currentRTPCall->rev_wav,currentRTPCall->both_wav);
                        SIPLOG("rtp_count = %d;fwd_count = %d;rev_count = %d\n",currentRTPCall->rtp_count,currentRTPCall->fwd_count,currentRTPCall->rev_count);
                        SIPLOG("fwd_seqCount = %d;rev_seqCount = %d\n",currentRTPCall->fwd_seqCount,currentRTPCall->rev_seqCount);
                }
        }
}

void siplogging(const char *fmt, ...){

        int n, size = 100;
        char *p;
        va_list ap;
        int ret=0;

        if(voipdebug == 1){

                if((p = (char *) malloc(size)) != NULL){

                        while(1) {

                                va_start(ap,fmt);
                                n = vsnprintf(p,size,fmt,ap);
                                va_end(ap);

                                if(n > -1 && n < size){
                                        if(sipfile != NULL){
                                                if((ret = fprintf(sipfile,"%s",p)) < 0){
                                                        INSTANT_USER_MSG("Error printing to file: %s\n",strerror(errno));
                                                        INSTANT_USER_MSG("Stopped sip logging\n");
                                                        voipdebug = 0;
                                                        free(p);
                                                        break;
                                                }
                                                fflush(sipfile);
                                                free(p);
                                                break;
                                        }
                                }

                                if(n > -1)
                                        size = n + 1;
                                else
                                        size *= 2;

				if((p= (char *) realloc(p,size)) == NULL)
                                        break;
                        }
                }
        }
}

void siprtplogging(const char *fmt, ...){

        int n, size = 100;
        char *p;
        va_list ap;
        int ret = 0;

        if(voipdebug == 1){

                if((p = (char *) malloc(size)) != NULL){

                        while(1) {

                                va_start(ap,fmt);
                                n = vsnprintf(p,size,fmt,ap);
                                va_end(ap);

                                if(n > -1 && n < size){
                                        if(sipfile != NULL){
                                                if((ret = fprintf(siprtpfile,"%s",p)) < 0){
                                                        INSTANT_USER_MSG("Error printing to file: %s\n",strerror(errno));
                                                        INSTANT_USER_MSG("Stopped rtp-sip logging\n");
                                                        voipdebug = 0;
                                                        free(p);
                                                        break;  
                                                }
                                                fflush(siprtpfile);
                                                free(p);
                                                break;
                                        }
                                }

                                if(n > -1)
                                        size = n + 1;
                                else
                                        size *= 2;

				if((p= (char *) realloc(p,size)) == NULL)
                                        break;
                        }
                }
        }
}

	
