#include <ec.h>
#include <targets.h>
#include <ec_liveMonitor.h>
#include <ec_audioDSPPlayer.h>
#include <ec_threads.h>
#include <errno.h>

int liveMonitorHandlerSkinny(struct rtp_data*, int, char,struct sniff_rtp *);
extern pthread_mutex_t player_mutex_skinny;
#define PLAYER_SKINNY_LOCK do{ pthread_mutex_lock(&player_mutex_skinny); } while(0)
#define PLAYER_SKINNY_UNLOCK do{ pthread_mutex_unlock(&player_mutex_skinny); } while(0)

extern pthread_mutex_t vlcstarted_mutex_skinny;
#define VLCSTARTED_SKINNY_LOCK do{ pthread_mutex_lock(&vlcstarted_mutex_skinny); } while(0)
#define VLCSTARTED_SKINNY_UNLOCK do{ pthread_mutex_unlock(&vlcstarted_mutex_skinny); } while(0)

#ifdef HAVE_LIB_VLC

void calSeqNoAndTimestamp(struct sniff_rtp*, struct sniff_rtp*, int);
int sendParameterSet(struct sniff_rtp*, rtpSKINNY*, int, int);
void sendRTPSKINNY(u_char *, int, int, int);
int sendIDRPictures(struct sniff_rtp *, struct idrPicture*, int, int); 

#endif

int liveMonitorHandlerSkinny(struct rtp_data* currentRTPCall, int fileType, char codecType, struct sniff_rtp *rtphdr){

	PLAYER_SKINNY_LOCK;
	
//printf ("Codec type is %c\n", codecType);
	if(currentRTPCall->liveMonitor == MONITOR_START){
	//printf("LiveMonitorFwdAudioCtr value is %d\n",currentRTPCall->liveMonitorFwdAudioCtr);
	//printf("Live monitor value = %d \n", currentRTPCall->liveMonitor);
	//printf("monitor started \n");
        if(fileType == FWDAUDIOFT){

            if(currentRTPCall->liveMonitorFwdAudioCtr == 0){
				
				switch(codecType){
					
					case COG722:
					case COG723:
					case COG726:
					case COG729:
						//printf(" One of the codec is detected in livemonitor handler skinny\n");
						if(currentRTPCall->audioDSPSet == 0){
							//printf("DSP got initialized \n");
							int retDSP = initDSP(16, 1, 8000);
							if(retDSP < 0){
								printf("Error in initializing DSP\n");
								PLAYER_SKINNY_UNLOCK;
								return -1;
							}
							currentRTPCall->audioDSPSet = 1;
						}
					break;
					case COG711MULAW:
						//printf(" G711 is detected in livemonitor handler skinny\n");
						if(currentRTPCall->audioDSPSet == 0){
							//printf("DSP got initialized \n");
							int retDSP = initDSP(8, 1, 8000);
							if(retDSP < 0){
								printf("Error in initializing DSP\n");
								PLAYER_SKINNY_UNLOCK;
								return -1;
							}
							currentRTPCall->audioDSPSet = 1;
						}
					break;
				}
                currentRTPCall->liveMonitorFwdAudioCtr += 1;
				PLAYER_SKINNY_UNLOCK;
                return 1;
            }
			else if(currentRTPCall->liveMonitorFwdAudioCtr > 0){
               	currentRTPCall->liveMonitorFwdAudioCtr += 1;
				PLAYER_SKINNY_UNLOCK;
                return 1;
            }
        }
		else if(fileType == REVAUDIOFT){

            if(currentRTPCall->liveMonitorRevAudioCtr == 0){

				switch(codecType){

					
                        case COG722:
                        case COG723:
                        case COG726:
                        case COG729:

			            if(currentRTPCall->audioDSPSet == 0){
			            	//printf("DSP got initialized and this is rev dsp\n");
                              	int retDSP = initDSP(16, 1, 8000);
                              	if(retDSP < 0){
								      PLAYER_SKINNY_UNLOCK;
                                  	return -1;
                              	}
                              	currentRTPCall->audioDSPSet = 1;
                          	}
				      break;
			      case COG711ALAW:
					//printf(" G711 is detected in livemonitor handler skinny\n");
					if(currentRTPCall->audioDSPSet == 0){
						//printf("DSP got initialized \n");
						int retDSP = initDSP(8, 1, 8000);
						if(retDSP < 0){
							printf("Error in initializing DSP\n");
							PLAYER_SKINNY_UNLOCK;
							return -1;
						}
						currentRTPCall->audioDSPSet = 1;
					}
      				break;
                }
                currentRTPCall->liveMonitorRevAudioCtr += 1;
				PLAYER_SKINNY_UNLOCK;
                return 1;
            }
            else if(currentRTPCall->liveMonitorRevAudioCtr > 0){
                currentRTPCall->liveMonitorRevAudioCtr += 1;
				PLAYER_SKINNY_UNLOCK;
                return 1;
            }
        }
		else if(fileType == FWDVIDEOFT){

            //printf("I am in filetype fwd video \n");

#ifdef HAVE_LIB_VLC

            if(currentRTPCall->liveMonitorFwdVideoCtr == 0){
				if(!currentRTPCall->liveMonitorSocket){
					currentRTPCall->liveMonitorSocket = socket(AF_INET, SOCK_DGRAM, 0);
					if(currentRTPCall->liveMonitorSocket < 0){
						printf("Error: creating live monitoring socket \n");
						PLAYER_SKINNY_UNLOCK;
						return -1;
					}
				}
printf("%s:%d - %s calling createSDPFileSkinny for forward video\n", __FILE__, __LINE__, __func__);			
				createSDPFileSkinny(fileType,&currentRTPCall->videoPayloadType);	
				//printf("SDP FIles created \n");

				startLiveMonitorPlayerSkinny(fileType, &(currentRTPCall->liveMonitorFwdVlcStarted));
				//printf("Live monitoring started function called \n");
				struct sniff_rtp newRTPHeader;
 //printf("Before callseqNo and timestamp \n");
				calSeqNoAndTimestamp(&newRTPHeader, rtphdr, currentRTPCall->fwdIDRCtr);
 //printf("after callseqNo and timestamp \n");
				 while (1){

				   		VLCSTARTED_SKINNY_LOCK;

						if(currentRTPCall->liveMonitorFwdVlcStarted){
							VLCSTARTED_SKINNY_UNLOCK;
							break;
						}

						VLCSTARTED_SKINNY_UNLOCK;
				}
                        //printf("Before sendparameterset and callseqNo and timestamp \n");
				int retParamSet = sendParameterSet(&newRTPHeader,currentRTPCall,FWDVIDEOPORT_INT_SKINNY, fileType);
				if(retParamSet < 0){
					/* Stop Currently Monitoring Stream */
					PLAYER_SKINNY_UNLOCK;
					return -1;
				}
				int retIDRPic = sendIDRPictures(&newRTPHeader,currentRTPCall->fwdIDRPtr,FWDVIDEOPORT_INT_SKINNY, currentRTPCall->liveMonitorSocket);
				if(retIDRPic < 0){
					/* Stop currently monitoring stream */
					PLAYER_SKINNY_UNLOCK;
					return -1;
				} 
                currentRTPCall->liveMonitorFwdVideoCtr += 1;
				PLAYER_SKINNY_UNLOCK;
                return 1;
            }
            else if(currentRTPCall->liveMonitorFwdVideoCtr > 0){
                currentRTPCall->liveMonitorFwdVideoCtr += 1;
				PLAYER_SKINNY_UNLOCK;
                return 1;
            }
#endif			
        }

        else if(fileType == REVVIDEOFT){
           //printf("I am in filetype rev video \n");
#ifdef HAVE_LIB_VLC
				
  if(currentRTPCall->liveMonitorRevVideoCtr == 0){
				if(!currentRTPCall->liveMonitorSocket){
					currentRTPCall->liveMonitorSocket = socket(AF_INET, SOCK_DGRAM, 0);
					if(currentRTPCall->liveMonitorSocket < 0){
						printf("Error: creating live monitoring socket \n");
						PLAYER_SKINNY_UNLOCK;
						return -1;
					}
				}
printf("%s:%d - %s calling createSDPFileSkinny for reverse video\n", __FILE__, __LINE__, __func__);			
				createSDPFileSkinny(fileType,&currentRTPCall->videoPayloadType);	
				//printf("SDP FIles created \n");

				startLiveMonitorPlayerSkinny(fileType, &(currentRTPCall->liveMonitorRevVlcStarted));
				//printf("Live monitoring started function called \n");
				struct sniff_rtp newRTPHeader;
 //printf("Before callseqNo and timestamp \n");
				calSeqNoAndTimestamp(&newRTPHeader, rtphdr, currentRTPCall->revIDRCtr);
 //printf("after callseqNo and timestamp \n");
				 while (1){

				   		VLCSTARTED_SKINNY_LOCK;

						if(currentRTPCall->liveMonitorRevVlcStarted){
							VLCSTARTED_SKINNY_UNLOCK;
							break;
						}

						VLCSTARTED_SKINNY_UNLOCK;
				}
                        //printf("Before sendparameterset and callseqNo and timestamp \n");
				int retParamSet = sendParameterSet(&newRTPHeader,currentRTPCall,REVVIDEOPORT_INT_SKINNY, fileType);
				if(retParamSet < 0){
					/* Stop Currently Monitoring Stream */
					PLAYER_SKINNY_UNLOCK;
					return -1;
				}
				int retIDRPic = sendIDRPictures(&newRTPHeader,currentRTPCall->revIDRPtr,REVVIDEOPORT_INT_SKINNY, currentRTPCall->liveMonitorSocket);
				if(retIDRPic < 0){
					/* Stop currently monitoring stream */
					PLAYER_SKINNY_UNLOCK;
					return -1;
				} 
                currentRTPCall->liveMonitorRevVideoCtr += 1;
				PLAYER_SKINNY_UNLOCK;
                return 1;
                }
		else if(currentRTPCall->liveMonitorRevVideoCtr > 0){
			currentRTPCall->liveMonitorRevVideoCtr += 1;
			PLAYER_SKINNY_UNLOCK;
			return 1;
		}
#endif			
	}

}
	PLAYER_SKINNY_UNLOCK;
    return -1;

}


#ifdef HAVE_LIB_VLC

int sendIDRPictures(struct sniff_rtp* newRTPHeader,struct idrPicture *idrPicturePtr,int port, int liveMonitorSocket){

	u_char *data = NULL;
	struct idrPicture *tempIDRPic = idrPicturePtr;
	unsigned short tempSequence_no;
	while(tempIDRPic != NULL){
		tempSequence_no = ntohs(newRTPHeader->sequence_no);
		tempSequence_no += 1;
	    newRTPHeader->sequence_no = htons(tempSequence_no);
		data = (u_char *) calloc(sizeof(struct sniff_rtp) + tempIDRPic->idrPictureLength + 1, sizeof(u_char));
		if(data == NULL){
			INSTANT_USER_MSG("Error: Allocating new memory for live monitoring\n");
			return -1;
		}

		/* set the Mark bit for the last IDR Picture */
		if(tempIDRPic->next == NULL)
			newRTPHeader->payloadType |= 0x80;

		memcpy(data,newRTPHeader,sizeof(struct sniff_rtp));
		memcpy(data+sizeof(struct sniff_rtp), tempIDRPic->idrPictureData, tempIDRPic->idrPictureLength);
		sendRTPSKINNY(data,sizeof(struct sniff_rtp) + tempIDRPic->idrPictureLength, port, liveMonitorSocket);

	    tempIDRPic = tempIDRPic->next;
		free(data);
	}
	return 0;
}

int sendParameterSet(struct sniff_rtp* newRTPHeader, rtpSKINNY* currentRTPCall, int port, int fileType){

	 if(fileType == FWDVIDEOFT){

		 u_char *data = (u_char *) calloc(sizeof(struct sniff_rtp) + strlen(currentRTPCall->fwdSPS) + 1, sizeof(u_char));
		 if(data == NULL){
	 		INSTANT_USER_MSG("Error: Allocating new memory for live monitoring\n");
        	return -1;
		 }
	 	memcpy(data,newRTPHeader,sizeof(struct sniff_rtp));
	 	memcpy(data+sizeof(struct sniff_rtp),currentRTPCall->fwdSPS,strlen(currentRTPCall->fwdSPS));
	 	sendRTPSKINNY(data,sizeof(struct sniff_rtp) + strlen(currentRTPCall->fwdSPS),port,currentRTPCall->liveMonitorSocket);

		unsigned short tempSequence_no = ntohs(newRTPHeader->sequence_no);
		tempSequence_no += 1;
	    newRTPHeader->sequence_no = htons(tempSequence_no);
	 	free(data);
	 	data = (u_char *) calloc(sizeof(struct sniff_rtp) + strlen(currentRTPCall->fwdPPS) + 1, sizeof(u_char));
	 	if(data == NULL){	
			INSTANT_USER_MSG("Error: Allocating new memory for live monitoring\n");																					     return -1;
	 	}	
	 	memcpy(data,newRTPHeader,sizeof(struct sniff_rtp));
     	memcpy(data+sizeof(struct sniff_rtp),currentRTPCall->fwdPPS,strlen(currentRTPCall->fwdPPS));
     	sendRTPSKINNY(data,sizeof(struct sniff_rtp)+strlen(currentRTPCall->fwdPPS),port, currentRTPCall->liveMonitorSocket);

	}
	else if(fileType == REVVIDEOFT){

		u_char *data = (u_char *) calloc(sizeof(struct sniff_rtp) + strlen(currentRTPCall->revSPS) + 1, sizeof(u_char));
		if(data == NULL){
			INSTANT_USER_MSG("Error: Allocating new memory for live monitoring\n");
			return -1;
		}
		memcpy(data,newRTPHeader,sizeof(struct sniff_rtp));
		memcpy(data+sizeof(struct sniff_rtp),currentRTPCall->revSPS,strlen(currentRTPCall->revSPS));
		sendRTPSKINNY(data,sizeof(struct sniff_rtp) + strlen(currentRTPCall->revSPS),port, currentRTPCall->liveMonitorSocket);
		
		unsigned short tempSequence_no = ntohs(newRTPHeader->sequence_no);
		tempSequence_no += 1;
		newRTPHeader->sequence_no = htons(tempSequence_no);
		free(data);
		data = (u_char *) calloc(sizeof(struct sniff_rtp) + strlen(currentRTPCall->revPPS) + 1, sizeof(u_char));
		 if(data == NULL){
			INSTANT_USER_MSG("Error: Allocating new memory for live monitoring\n");
			return -1;
		}
		memcpy(data,newRTPHeader,sizeof(struct sniff_rtp));
		memcpy(data+sizeof(struct sniff_rtp),currentRTPCall->revPPS,strlen(currentRTPCall->revPPS));
		sendRTPSKINNY(data,sizeof(struct sniff_rtp)+strlen(currentRTPCall->revPPS),port, currentRTPCall->liveMonitorSocket);
	}
	return 0;
}

void calSeqNoAndTimestamp(struct sniff_rtp* newRTPHeader, struct sniff_rtp* rtphdr, int IDRCtr){

	unsigned short calsequence_no = ntohs(rtphdr->sequence_no) - (IDRCtr + 2); /* 2 - pps and sps */
	unsigned int caltimestamp = ntohl(rtphdr->timestamp) - 3000; /* 3600 for 25 fps */

    newRTPHeader->version = rtphdr->version;
	newRTPHeader->payloadType = (rtphdr->payloadType & 0x7F);
    newRTPHeader->sequence_no = htons(calsequence_no);
	newRTPHeader->timestamp = htonl(caltimestamp);
    newRTPHeader->ssrc = rtphdr->ssrc;

}

void sendRTPSKINNY(u_char *data, int dataLength, int dstPort, int liveMonitorSocket){

	struct sockaddr_in dstaddr;
	dstaddr.sin_family = AF_INET;
	dstaddr.sin_addr.s_addr = inet_addr(myIP);
	dstaddr.sin_port = htons(dstPort);

	int length = sendto(liveMonitorSocket, (u_char *)data, dataLength, 0, (struct sockaddr*)&dstaddr, sizeof(dstaddr));
	if(length < 0){
		printf("Error: Sending RTP data to live monitor stream : %s\n",strerror(errno));
		return;
	}
}

void deleteIDRPictureSKINNY(struct idrPicture *idrPicturePtr){

	if(idrPicturePtr == NULL)
		return;

	struct idrPicture *tempIDRPic = NULL;
	tempIDRPic = idrPicturePtr;
	
	while(tempIDRPic != NULL){

		struct idrPicture *deleteIDRPic = tempIDRPic;
		tempIDRPic = tempIDRPic->next;
		free(deleteIDRPic);
	}

	idrPicturePtr = NULL;
}

#endif

