#include "stdio.h"
#include "stdlib.h"
#include "sys/types.h"
#include "sys/time.h"
#include "string.h"
#include "strings.h"
#include "EasyG7231.h"
#include "EasyG7231_macros.h"

extern "C" {
	int initialize_g723_decoder(unsigned long *, int);
};
extern "C" {
	int decode_payload_g723(u_char *, int ,short *, int *, unsigned long, int);
};
extern "C" {
	void release_g723_decoder(unsigned long);
}

int initialize_g723_decoder(unsigned long *hDecoder, int frameType){

	bool fType = true;
	if(frameType)
		fType = true;
	else if(!frameType)
		fType = false;

    *hDecoder = EasyG7231_init_decoder(fType);
	if(*hDecoder < 0)
		return -1;

    return 0;
}

int decode_payload_g723(u_char *payload, int size_payload,short *synth, int *synthLength, unsigned long hDecoder, int frameType){

	int num_of_frame_compressed = 0;
	int frameCompressionValue = 0;

	if(frameType)
		frameCompressionValue = L_G7231_FRAME_COMPRESSED_63;
	else
		frameCompressionValue = L_G7231_FRAME_COMPRESSED_53;
	
	num_of_frame_compressed = size_payload / frameCompressionValue;

	unsigned char *serial;

	serial = (unsigned char*) calloc(frameCompressionValue, sizeof(unsigned char));
	if(serial == NULL){
		printf("[-] Error allocating memory for serial buffer \n");
		return -1;
	}
/*
	*synth = (short *) calloc(L_G7231_FRAME * num_of_frame_compressed, sizeof(short));
    if(*synth == NULL){
        printf("Error: not enough memory available for allocation \n");
        return -1;
    }
 */
    short *tempSynth = synth;

    int i = 0;
    for(i = 0; i < num_of_frame_compressed; i++){

        memcpy(serial, payload + (i * frameCompressionValue), frameCompressionValue);
        EasyG7231_decoder(hDecoder, serial, tempSynth );

        memset(serial, '\0', frameCompressionValue);
        tempSynth += L_G7231_FRAME;
    }

	*synthLength = L_G7231_FRAME * num_of_frame_compressed;

    return 0;
}

void release_g723_decoder(unsigned long hDecoder){
	
	EasyG7231_release_decoder( hDecoder );
}

