#include "ec.h"
#include "EasyG726.h"

int initialize_g726_decoder(unsigned long *);
int decode_payload_g726(u_char*, int, short *, int *, unsigned long, int);
void release_g726_decoder(unsigned long);

int initialize_g726_decoder(unsigned long *hDecoder){

    *hDecoder = EasyG726_init_decoder();
	if(*hDecoder<0)
		return -1;

    return 0;
}

int decode_payload_g726(u_char *payload, int size_payload, short *synth, int *synthLength, unsigned long hDecoder, int sampleSize){

    unsigned char *serial;
    short *tempSynth;
	unsigned char codeCur;
	serial = (unsigned char*)calloc(size_payload,sizeof(unsigned char));
	if(serial == NULL){
		printf("[-] Cannot allocate memory for serial buffer\n");
		return -1;
	}
/*
	*synth = (short*) calloc(size_payload * 2, sizeof(short));
	if(*synth == NULL){
		printf("[-] Cannot allocate memory for synth buffer\n");
		return -1;
	}
 */	
	tempSynth = synth;
	int i = 0;
    for(i = 0;i < size_payload;i++){

		codeCur = (serial[i] & 0xF0) >> 4;
        EasyG726_decoder(hDecoder, &codeCur, (tempSynth+2*i), 3, sampleSize );

        codeCur = serial[i] & 0x0F;
        EasyG726_decoder(hDecoder, &codeCur, (tempSynth+2*i+1), 3, sampleSize );

    }
	*synthLength = size_payload * 2;
    return 0;
}

void release_g726_decoder(unsigned long hDecoder){
	
	EasyG726_release_decoder(hDecoder);
}
