#include "stdio.h"
#include "stdlib.h"
#include "sys/types.h"
#include "sys/time.h"
#include "string.h"
#include "strings.h"
#include "EasyG729A.h"

extern "C" {
	int initialize_g729_decoder(unsigned long *);
};
extern "C" {
	int decode_payload_g729(u_char *, int, short *, int *, unsigned long );
};
extern "C" {
	void release_g729_decoder(unsigned long);
};

int initialize_g729_decoder(unsigned long *hDecoder){
	
	*hDecoder = EasyG729A_init_decoder();
	if(*hDecoder < 0)
		return -1;

	return 0;
}

int decode_payload_g729(u_char *payload, int size_payload, short *synth, int *synthLength, unsigned long hDecoder){

	unsigned char serial[L_G729A_FRAME_COMPRESSED];
    int num_of_frame_compressed = size_payload / L_G729A_FRAME_COMPRESSED;
/*    
	*synth = (short *) calloc(L_G729A_FRAME * num_of_frame_compressed, sizeof(short));
	if(*synth == NULL){
		printf("Error: not enough memory available for allocation \n");
		return -1;
	}
 */
	short *tempSynth = synth;
    int i = 0;
    for(i = 0; i < num_of_frame_compressed; i++){

    	memcpy(serial, payload + (i * L_G729A_FRAME_COMPRESSED), L_G729A_FRAME_COMPRESSED);
        EasyG729A_decoder(hDecoder, serial, tempSynth );

        memset(serial, '\0', sizeof(serial));
		tempSynth += L_G729A_FRAME;
	}
	
	*synthLength = L_G729A_FRAME * num_of_frame_compressed;
	
	return 0;
}

void release_g729_decoder(unsigned long hDecoder){
	
	EasyG729A_release_decoder(hDecoder);
}

