/*
 * Originally created: July 5, 1991
 * Copyright 1991 Lance Norskog And Sundry Contributors
 * This source code is freely redistributable and may be used for
 * any purpose.  This copyright notice must be maintained.
 * Lance Norskog And Sundry Contributors are not responsible for
 * the consequences of using this software.
 */

#include "st_i.h"
#include "btrworth.h"

/*
 * Sound Tools file format and effect tables.
 */

/* File format handlers. */

/* SGI/Apple AIFF */

/* Commenting these un-needed variables on version 2.61 */

/*
static char *aiffnames[] = {
        "aiff",
        "aif",
        (char *) 0
};

*/

/* a-law byte raw */
/*
static char *alnames[] = {
        "al",
        (char *) 0
};
*/

/* #if     defined(HAVE_ALSA) */
/* /dev/snd/pcmXX */
/*
static char *alsanames[] = {
        "alsa",
        (char *) 0
};
#endif
*/
/* SPARC .au w/header */

static char *aunames[] = {
        "au",
        "snd",
        (char *) 0
};

static char *autonames[] = {
        "auto",
        (char *) 0
};

/*
static char *avrnames[] = {
        "avr",
        (char *) 0
};

static char *cdrnames[] = {
        "cdr",
        (char *) 0
};
*/

/* Cont. Variable Slope Delta */
/*
static char *cvsdnames[] = {
        "cvs",
        "cvsd",
        (char *)0
};
*/
/* Text data samples */
/*
static char *datnames[] = {
        "dat",
        (char *) 0
};
*/
/* Cont. Variable Solot Delta */
/*
static char *dvmsnames[] = {
        "vms",
        "dvms",
        (char *)0
};
*/
/* #ifdef ENABLE_GSM */
/* GSM 06.10 */
/*
static char *gsmnames[] = {
        "gsm",
        (char *) 0
};
#endif
*/

/* Mac FSSD/HCOM */ /*
static char *hcomnames[] = {
        "hcom",
        (char *) 0
};
*/
/* inverse a-law byte raw */
/*
static char *lanames[] = {
        "la",
        (char *) 0
};
*/

/* inverse u-law byte raw */
/*
static char *lunames[] = {
        "lu",
        (char *) 0
};
*/
/* Amiga MAUD */
/*
static char *maudnames[] = {
        "maud",
        (char *) 0,
};

#if defined(HAVE_LIBMAD) || defined(HAVE_LAME) */
/* MP3 */ 
/*
static char *mp3names[] = {
        "mp3",
        "mp2",
        (char *) 0,
};
#endif

static char *nulnames[] = {
        "nul",
        (char *) 0,
};

#if     defined(HAVE_OSS)

*/

/* OSS /dev/dsp player */
/*
static char *ossdspnames[] = {
        "ossdsp",
        (char *) 0
};
#endif
*/
/* Psion .prc */
/*
static char *prcnames[] = {
      "prc",
      (char *) 0
};

static char *rawnames[] = {
        "raw",
        (char *) 0
};
*/
/* raw prototypes are defined in st.h since they are used globally. */
/*
static char *sbnames[] = {
        "sb",
        (char *) 0
};
*/
/* IRCAM Sound File */
/*
static char *sfnames[] = {
        "sf",
        (char *) 0
};

static char *slnames[] = {
        "sl",
        (char *) 0,
};
*/
/* SampleVision sound */
/*
static char *smpnames[] = {
        "smp",
        (char *) 0,
};
*/
/* Sndtool Sound File */
/*
static char *sndtnames[] = {
        "sndt",
        (char *) 0
};
*/
/* NIST Sphere File */
/*
static char *spherenames[] = {
        "sph",
        (char *) 0
};

#if     defined(HAVE_SUNAUDIO) */
/* Sun /dev/audio player */
/*
static char *sunnames[] = {
        "sunau",
        (char *) 0
};
#endif
*/
/* Amiga 8SVX */
/*
static char *svxnames[] = {
        "8svx",
        (char *) 0
};

static char *swnames[] = {
        "sw",
        (char *) 0
};
*/
/* Yamaha TX16W and SY99 waves */
/*
static char *txwnames[] = {
    "txw",
    (char *)0
};

static char *ubnames[] = {
        "ub",
        "sou",
        "fssd",
        (char *) 0
};

static char *ulnames[] = {
        "ul",
        (char *) 0
};

static char *uwnames[] = {
        "uw",
        (char *) 0
};
*/
/* Sound Blaster .VOC */
/*
static char *vocnames[] = {
        "voc",
        (char *) 0
};

#ifdef HAVE_LIBVORBIS */
/* Ogg Vorbis */
/*
static char *vorbisnames[] = {
        "vorbis",
        "ogg",
        (char *) 0
};
#endif

static char *voxnames[] = {
        "vox",
        (char *) 0
};
*/
/* Microsoftt RIFF */

static char *wavnames[] = {
        "wav",
        (char *) 0
};

/* Psion .wve */
/*
static char *wvenames[] = {
      "wve",
      (char *) 0
};
*/
st_format_t st_formats[] = {
    {aunames, ST_FILE_STEREO | ST_FILE_SEEK,
        st_austartread, st_auread, st_rawstopread,
        st_austartwrite, st_auwrite, st_austopwrite,
        st_auseek},
    {autonames, ST_FILE_STEREO,
        st_autostartread, st_format_nothing_io, st_format_nothing,
        st_autostartwrite, st_format_nothing_io, st_format_nothing,
        st_format_nothing_seek},
    {wavnames, ST_FILE_STEREO | ST_FILE_SEEK,
	st_wavstartread, st_wavread, st_wavstopread,
	st_wavstartwrite, st_wavwrite, st_wavstopwrite, st_wavseek},
    {0, 0,
        0, 0, 0, 0, 0, 0, 0}
};

/* Effects handlers. */

/*
 * ST_EFF_CHAN means that the number of channels can change.
 * ST_EFF_RATE means that the sample rate can change.
 * ST_EFF_MCHAN means that the effect is coded for multiple channels.
 *
 */

st_effect_t st_effects[] = {
        {0, 0, 0, 0, 0, 0, 0}
};


