/*
    ucsniff - UCSniff - UC Sniffer
    Copyright (C) 2009 Sipera Systems, Inc. 
    Jason Ostrom <jostrom@viperlab.net>
    Arjun Sambamoorthy <arjun@viperlab.net>

    This file is part of UCSniff.

    UCSniff is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    UCSniff is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <tftp_client.h>

// From directory_parser.c
extern int directory_count;
//extern struct corporate_directory directory[1024];

// globals
extern int monitor_yes;

// From ec_text.c
extern void text_users_list(void);

int parse_directory_users(void);
void monitor_mode_init(void);

int parse_directory_users() {

	FILE *fdirusers;
	char *token;
	
	fdirusers = fopen("directory-users.txt", "r");
	if (fdirusers == NULL) {

		printf("File directory-users.txt can't be opened for reading in working directory\n");
		return 0;
	}

	int close;
	int length = 128;
	char temp[length];

	while (fgets(temp, length, fdirusers) != NULL) {

		char *search = ",";

		token = strtok(temp, search);
		strcpy(directory[directory_count].name, token);

		token = strtok(NULL, search);
		strcpy(directory[directory_count].telephone_number, token);
		int len = strlen(directory[directory_count].telephone_number);

		int offset = len - 1;
		directory[directory_count].telephone_number[offset] = '\0';

		directory_count++;

	}

	printf("Parsed %d entries in Directory Users file, directory-users.txt\n",directory_count);

	close = fclose(fdirusers);

	return directory_count;

}
void monitor_mode_init(void){

	if (monitor_yes != 1) {
		return;
	}

	int retval;
	printf("Running in Monitor Mode\n");

	retval = parse_directory_users();

}
