#include "queue.h"
#include "stdio.h"
#include "stdlib.h"

struct Queue *queueHead;
struct Queue *queueTail;

static pthread_mutex_t queue_mutex = PTHREAD_MUTEX_INITIALIZER;
#define QUEUE_LOCK do { pthread_mutex_lock(&queue_mutex); } while(0)
#define QUEUE_UNLOCK do { pthread_mutex_unlock(&queue_mutex); } while(0)

void addToQueue(void(*)());
void (*getFromQueue(void))();

void addToQueue(void(*funcPtr)(void)){

	QUEUE_LOCK;

	struct Queue *currentQ = (struct Queue *) malloc(1 * sizeof(struct Queue));
		if(currentQ == NULL){
			printf("Error: Allocating memory in gui queue\n");
			QUEUE_UNLOCK;
			return;
		}

		currentQ -> funcPtr = funcPtr;
		currentQ-> next  = NULL;

	if(queueHead == NULL){
		
		queueHead = queueTail = currentQ;
	}
	else{

		queueTail->next = currentQ;
		queueTail = currentQ;
	}
	
	QUEUE_UNLOCK;	
}

void (*getFromQueue(void)) (void){

	QUEUE_LOCK;

	if(queueHead != NULL){

		struct Queue *currentQ = queueHead;
		void (*tempFuncPtr)(void) = queueHead->funcPtr;
		queueHead = queueHead->next;
		free(currentQ);
		QUEUE_UNLOCK;
		return tempFuncPtr;
	}
	
	QUEUE_UNLOCK;
	return NULL;

}
