#include <ec.h>
#include <fcntl.h>
#include <sys/ioctl.h>
//#include <sys/ipc.h>
//#include <sys/sem.h>
#include <linux/soundcard.h>
#include <alsa/asoundlib.h>
#include <ec_audioDSPPlayer.h>
#include <errno.h>
#include <ec_ui.h>
#include <targets.h>
#include <ec_siplog.h>

static const int PERIOD_SIZE = 32;

int devfd = 0;
static  snd_pcm_t* pcm_handle = NULL;
int initDSP(int, int, int);
int killDSP();
static int openDSP(int, int, int);
//static int lockDSP();
//static int unlockDSP();
static int closeDSP();
int playDSP(short *, int,int);
static void mixTwoBuf(int);

short *fwdBuf;
short *revBuf;
short *bothBuf;
int fwdSet = 0, revSet = 0;

/* Locks the /dev/dsp semaphore and opens the device's file descriptor for writing */

int initDSP(int sampleSize, int channels, int sampleRate){

  devfd = 0;
  
  /*
    int returnLock = lockDSP();
    if(returnLock < 0){
    printf("[Debug-Audio-DSP-Player]: Not playing the audio \n");
    return -1;
    }
  */
  
  /* devfd = openDSP(sampleSize, channels, sampleRate); */
  /* if(devfd < 0){ */
  /* 	SIPLOG("[Debug-Audio-DSP-Player]: Not playing the audio \n"); */
  /* 	return -1; */
  /* } */
  
  snd_pcm_hw_params_t *hwparams;

  snd_pcm_hw_params_alloca(&hwparams);
  if(snd_pcm_open(&pcm_handle, "default", SND_PCM_STREAM_PLAYBACK, 0) < 0) {
    DEBUG_MSG("[Debug-Audio-DSP=Player]: Not playing the audio \n");
    return -1;
  }

  if(snd_pcm_hw_params_any(pcm_handle, hwparams) < 0) {
    DEBUG_MSG("[Debug-Audio-DSP-Player]: Error openig PCM device.");
  }

  if(snd_pcm_hw_params_set_access(pcm_handle, hwparams, 
				  SND_PCM_ACCESS_RW_INTERLEAVED) < 0) {
    DEBUG_MSG("[Debug-Audio-DSP-Player]: Error setting access.");
    return -1;
  }
	
  if(snd_pcm_hw_params_set_format(pcm_handle, hwparams, SND_PCM_FORMAT_S16_LE) < 0) {
    DEBUG_MSG("[Debug-Audio-DSP-Player]: Error setting format.");
    return -1;
  }

  int dir;
  if(snd_pcm_hw_params_set_rate_near(pcm_handle, hwparams, &sampleRate, &dir) < 0) {
    DEBUG_MSG("[Debug-Audio-DSP-Player]: Error setting rate.");
    return -1;
  }

  if(snd_pcm_hw_params_set_channels(pcm_handle, hwparams, channels) < 0) {
    DEBUG_MSG("[Debug-Audio-DSP-Player]: Error setting channels.");
    return -1;
  }

  snd_pcm_uframes_t frames = PERIOD_SIZE;
  if(snd_pcm_hw_params_set_period_size_near(pcm_handle, hwparams, 
					    &frames, &dir) < 0) {
    DEBUG_MSG("[Debug-Audio-DSP-Player]: Error setting periods.");
    return -1;
  }

//    if(snd_pcm_hw_params_set_periods(pcm_handle, hwparams, 4, 0) < 0) {
//   DEBUG_MSG("[Debug-Audio-DSP-Player]: Error setting periods.");
//    return -1;
//    }
//    if(snd_pcm_hw_params_set_buffer_size(pcm_handle, hwparams, sampleSize) < 0) {
//    DEBUG_MSG("[Debug-Audio-DSP-Player]: Error setting buffersize.");
//    return -1;
//    }
//  
  if(snd_pcm_hw_params(pcm_handle, hwparams) < 0) {
    DEBUG_MSG("[Debug-Audio-DSP-Player]: Error setting HW params.");
    return -1;
  }
  
  fwdSet = 0, revSet = 0; fwdBuf = NULL; revBuf = NULL; bothBuf = NULL;
  return 0;
}	

/* Unlocks the /dev/dsp semaphore and closes the device file descriptor */

int killDSP(){
  if(pcm_handle != NULL) {
    snd_pcm_drain(pcm_handle);
  }
	/* int returnClose = closeDSP(); */
	/* if(returnClose < 0){ */
	/* 	SIPLOG("[Debug-Audio-DSP-Player]: Failed closing the audio device \n"); */
	/* 	return -1; */
	/* } */

	/*
	int returnUnLock = unlockDSP();
    if(returnUnLock < 0){
        printf("[Debug-Audio-DSP-Player]: Unable to unlock the audio device /dev/dsp \n");
        return -1;
    }
	*/

	return 0;
}

/* LockDSP, locks the semaphore for /dev/dsp */
/*
static int lockDSP(){
	*/
	/* 0 = semaphore 0 for playing, -1 for locking, SEM_UNDO - reset the value of the semaphore after terminating */
/*	static struct sembuf sops[1] = { { 0, -1, SEM_UNDO } };
		 
	int retSem = semop(AUDIOIPC_LOCK, sops, 1);
	if(retSem < 0){

		SIPLOG("[Debug-Audio-DSP-Player]: Failed locking the audio device semaphore \n");
		return -1;
	}

	return 0;

}
*/
/* UnlockDSP, unlocks the semaphore for /dev/dsp */
/*
static int unlockDSP(){

*/	/* 0 = semaphore 0 for playing, +1 for unlocking, SEM_UNDO - reset the value of the semaphore after terminating */
/*    static struct sembuf sops[1] = { { 0, +1, SEM_UNDO } };

	int retSem = semop(AUDIOIPC_LOCK, sops, 1);
    if(retSem < 0){

        SIPLOG("[Debug-Audio-DSP-Player]: Failed unlocking the audio device semaphore \n");
        return -1;
    }

    return 0;

}
*/
/* This function opens the audio device and initializes the audio sample size, channel mode and sample rate */

static int openDSP(int sampleSize, int channel, int sampleRate){

	int status = 0;		/* Return status of the ioctl */
	int args = 0;		/* Argument for the ioctl */


	if((devfd = open("/dev/dsp", O_WRONLY)) < 0){

		SIPLOG("[Debug-Audio-DSP-Player]: Failed opening audiodevice /dev/dsp : %s \n",strerror(errno));
		//unlockDSP();
		return devfd;
	}

	/* Initialize the audio device with sample size */
	args = sampleSize;
	status = ioctl(devfd, SOUND_PCM_WRITE_BITS, &args);
	if(status < 0){
		SIPLOG("[Debug-Audio-DSP-Player]: Failed initializing the device with sample size : %s \n",strerror(errno));
		//unlockDSP();
		return -1;
	}

	/* Initialize the audio device with the channel mode */	
	args = channel;
	status = ioctl(devfd, SOUND_PCM_WRITE_CHANNELS, &args);
	if(status < 0){
		SIPLOG("[Debug-Audio-DSP-Player]: Failed initializing the device with audio channel : %s \n", strerror(errno));
		//unlockDSP();
		return -1;
	}

	/* Initialize the audio device with the sample rate */
	args = sampleRate;
	status = ioctl(devfd, SOUND_PCM_WRITE_RATE, &args);
	if(status < 0){
		SIPLOG("[Debug-Audio-DSP-Player]: Failed initializing the device with the sample rate : %s \n",strerror(errno));
		//unlockDSP();
		return -1;
	}

	return devfd;
}

void playFrames(short* data, int dataLength) {
  int i = 0, framesPlayed = 0, framesToPlay = 0;
  while(i < dataLength/2) {
    if((dataLength - i) < PERIOD_SIZE) {
      framesToPlay = dataLength / 2;
    }
    else
      framesToPlay = PERIOD_SIZE;
    framesPlayed = snd_pcm_writei(pcm_handle, &data[i], framesToPlay);
    //DEBUG_MSG("1 i=%d, framesPlayed=%d, framesToPlay=%d\n");
    if(framesPlayed == -EPIPE) {
	DEBUG_MSG("[Debug-Audio-DSP-Player]: Over/under flow\n");
	if(snd_pcm_prepare(pcm_handle) < 0)
	  DEBUG_MSG("[Debug-Audio-DSP-Player]: snd_pcm_prepare failed.\n");
    }
    else
      i += framesPlayed; // 2 bytes per channel
  }
}

/* This function closes the device descriptor */
static int closeDSP(){

	if(devfd > 0){
		close(devfd);
	}
	else{
		SIPLOG("[Debug-Audio-DSP-Player]: Device descriptor is not open \n");
		return -1;
	}

	return 0;
}

/* playDSP function writes the digital audio data to the audio device */
int playDSP(short *data, int dataLength, int fileType){

	if(fileType == 2){
	
			int bytes = 0;
	
			if(revSet == 1 && fwdSet == 0){
				
				fwdBuf = (short *) calloc(dataLength, sizeof(short));
				if(fwdBuf == NULL){
					INSTANT_USER_MSG("Error: allocating memory for fwdBuf \n");
					return -1;
				}
				memcpy(fwdBuf,data,dataLength);

				bothBuf = (short *) calloc(dataLength, sizeof(short));
				if(bothBuf == NULL){
					INSTANT_USER_MSG("Error: allocating memory for bothBuf \n");
					return -1;
				}

				mixTwoBuf(dataLength);
				//bytes = write(devfd, bothBuf, dataLength);
				playFrames(bothBuf, dataLength);
				/* if(bytes != dataLength){ */
				/* 	SIPLOG("[Debug-Audio-DSP-Player]: Error writing entire data to the audio device : %s \n", strerror(errno)); */
				/* 	return -1; */
				/* } */

				revSet = 0; fwdSet = 0;
				free(fwdBuf); free(revBuf); free(bothBuf);
			}
			else if(revSet == 0 && fwdSet == 1){

			  //bytes = write(devfd,fwdBuf,dataLength);
			  playFrames(fwdBuf, dataLength);
				/* if(bytes != dataLength){ */
				/* 	SIPLOG("[Debug-Audio-DSP-Player]: Error writing entire data to the audio device : %s \n", strerror(errno)); */
				/* 	return -1; */
				/* } */

				fwdSet = 1;
				memset(fwdBuf,'\0',dataLength);
				memcpy(fwdBuf,data,dataLength);
			}
			else if(revSet == 0 && fwdSet == 0){

				fwdBuf = (short *) calloc(dataLength, sizeof(short));
				if(fwdBuf == NULL){
					INSTANT_USER_MSG("Error: allocating memory for fwdBuf \n");
					return -1;
				}
				memcpy(fwdBuf,data,dataLength);
				fwdSet = 1;
			}
	}
	else if(fileType == 3){
		int bytes = 0;

		if(fwdSet == 1 && revSet == 0){

				revBuf = (short *) calloc(dataLength, sizeof(short));
				if(revBuf == NULL){
					INSTANT_USER_MSG("Error: allocating memory for revBuf \n");
					return -1;
				}
                memcpy(revBuf,data,dataLength);
				 bothBuf = (short *) calloc(dataLength, sizeof(short));
                if(bothBuf == NULL){
                    INSTANT_USER_MSG("Error: allocating memory for bothBuf \n");
                    return -1;
                }	
                mixTwoBuf(dataLength);
                //bytes = write(devfd, bothBuf, dataLength);
		playFrames(bothBuf, dataLength);
                /* if(bytes != dataLength){ */
                /*     SIPLOG("[Debug-Audio-DSP-Player]: Error writing entire data to the audio device : %s \n", strerror(errno)); */
                /*     return -1; */
                /* } */

                revSet = 0; fwdSet = 0;
				free(fwdBuf); free(revBuf); free(bothBuf);
            }
            else if(fwdSet == 0 && revSet == 1){
                if (bothBuf != NULL) {
                //bytes = write(devfd,revBuf,dataLength);
                    playFrames(bothBuf, dataLength);
                    /* if(bytes != dataLength){ */
                    /*     SIPLOG("[Debug-Audio-DSP-Player]: Error writing entire data to the audio device : %s \n", strerror(errno)); */
                    /*     return -1; */
                    /* } */

                    revSet = 1;
                    if(revBuf != NULL) {
                        memset(revBuf,'\0',dataLength);
                        memcpy(revBuf,data,dataLength);
                    }
				}
            }
            else if(fwdSet == 0 && revSet == 0){

				revBuf = (short *) calloc(dataLength, sizeof(short));
                if(revBuf == NULL){
                    INSTANT_USER_MSG("Error: allocating memory for revBuf \n");
                    return -1;
                }
                memcpy(revBuf,data,dataLength);
                revSet = 1;
            }

	}
	return 0;
}

static void mixTwoBuf(int dataLength){

	int i = 0;
	for(i = 0; i < dataLength; i++)
		bothBuf[i] = (fwdBuf[i] + revBuf[i])/2;

}

