#include <ec_voiplogfiles.h>
#include <ec_voipglobals.h>

void initVoipLogFiles(){

	file_name = "call.log";
	detail_file_name = "calldetail.log";
	skinny_fname = "skinny.log";
	targetsfile = "targets.txt";
	sip_fname = "sip.log";
	siprtp_fname = "siprtp.log";
	sipPcapDump = "sipdump.pcap";
}

void openVoipLogFiles(){

   //open file call log
   ofile = fopen(file_name, "a+");
   if (ofile == NULL) {
        INSTANT_USER_MSG ("Error: Unable to open the file %s\n",file_name);
        exit(8);
   }

   // Open the detail call file
   odetailfile = fopen(detail_file_name, "a+");
   if (odetailfile == NULL) {
        INSTANT_USER_MSG ("Error:  Unable to open the file %s\n",detail_file_name);
        exit (8);
   }

   // Open the skinny messages file
   sccpfile = fopen(skinny_fname, "a+");
   if (sccpfile == NULL) {
        INSTANT_USER_MSG ("Error:  Unable to open the file %s\n",skinny_fname);
        exit (8);
   }

   sipfile = fopen(sip_fname,"w+");
   if(sipfile == NULL){
        INSTANT_USER_MSG("Error: Unable to open file %s\n",sip_fname);
        exit(8);
   }

   if(voipdebug){

        siprtpfile = fopen(siprtp_fname, "w+");
        if(siprtpfile == NULL){
                INSTANT_USER_MSG( "Error: Unable to open file %s\n",siprtp_fname);
                exit(8);
        }
    }
	
    //Open SIP dumping file
   sipdp = pcap_open_dead(DLT_EN10MB,1024);
   if(sipdp == NULL){
        INSTANT_USER_MSG("Error: Creating pcap handle for sip message dumping\n");
        exit (8);
   }

   sipdumper = pcap_dump_open(sipdp,sipPcapDump);
   if(sipdumper == NULL){
        INSTANT_USER_MSG("Error: Opening sip dump file %s \n",sipPcapDump);
        exit (8);
   }

}

void closeVoipLogFiles(){

   pcap_dump_close(sipdumper);
   pcap_close(sipdp);

   fclose(ofile);
   fclose(odetailfile);
   fclose(sccpfile);
   fclose(sipfile);
   if(voipdebug){
        fclose(siprtpfile);
   }

} 
