/*
    ucsniff - UCSniff - UC Sniffer
    Copyright (C) 2009 Sipera Systems, Inc. 
    Jason Ostrom <jostrom@viperlab.net>
    Arjun Sambamoorthy <arjun@viperlab.net>

    This file is part of UCSniff.

    UCSniff is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    UCSniff is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "includes.h"
#include "tftp_client.h"
#include <unistd.h>
#include "client.h"
#include "errno.h"
#include "time.h"
#include "fcntl.h"
#ifndef OS_WINDOWS

#include "syslog.h"
#include "sys/ioctl.h"
#include "sys/stat.h"
#include "voiphop.h"
#include "net/route.h"

#endif

void remove_interface(char *RemovedInterface){

#ifndef OS_WINDOWS

        printf("Removing interface %s\n",RemovedInterface);

        struct vlan_ioctl_args if_request;
        int fd;

        strcpy(if_request.device1, RemovedInterface);

        if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
                fprintf(stderr, "Fatal:  Couldn't open socket\n");
                        exit(2);
        }

        if_request.cmd = DEL_VLAN_CMD;
        if (ioctl(fd, SIOCSIFVLAN, &if_request) < 0) {
                fprintf(stderr, "Error trying to remove VLAN Interface %s.  Error: %s\n", RemovedInterface, strerror(errno));
        } else {
                fprintf(stdout, "Removed VLAN Interface %s\n", RemovedInterface);
        }
#else
		printf("To remove the interface in windows, please uninstall the driver\n");

#endif
}

int check_mac_format(char *mac){
	
	int nbyte = 5;

	for (nbyte=2; nbyte<16; nbyte+=3) {
                if (mac[nbyte] != ':') {
                        fprintf (stderr, "Incorrect format: %s\n",mac);
                        return -1;
                }
        }
	return 0;

}
